import { RecorderDecoratorsInternal } from "../implementation/recorder-decorators-internal";
import { StringStreamMarker, BinaryStreamMarker } from "./lazy-ref";
export var RecorderDecorators;
(function (RecorderDecorators) {
    function property() {
        var options = { persistent: true };
        if (arguments.length > 0) {
            options = arguments[0];
        }
        return RecorderDecoratorsInternal.property(options);
    }
    RecorderDecorators.property = property;
    function playerObjectId() {
        return RecorderDecoratorsInternal.playerObjectId();
    }
    RecorderDecorators.playerObjectId = playerObjectId;
    /**
     * Decorator for persistent entity.
     *
     * Sample:
     * ```ts
     * ...
     * @JsonPlayback.playerType({playerType: 'org.mypackage.MyPersistentEntity'})
     * export class MyPersistentEntityJs {
     * ...
     * ```
     */
    function playerType(options) {
        return RecorderDecoratorsInternal.playerType(options);
    }
    RecorderDecorators.playerType = playerType;
    RecorderDecorators.DateProcessor = RecorderDecoratorsInternal.DateProcessor;
    RecorderDecorators.BufferProcessor = RecorderDecoratorsInternal.BufferProcessor;
    RecorderDecorators.StringProcessor = RecorderDecoratorsInternal.StringProcessor;
    RecorderDecorators.BinaryStreamProcessor = RecorderDecoratorsInternal.BinaryStreamProcessor;
    RecorderDecorators.StringStreamProcessor = RecorderDecoratorsInternal.StringStreamProcessor;
    RecorderDecorators.TypeProcessorEntries = [
        {
            type: Buffer,
            processor: RecorderDecorators.BufferProcessor
        },
        {
            type: String,
            processor: RecorderDecorators.StringProcessor
        },
        {
            type: BinaryStreamMarker,
            processor: RecorderDecorators.BinaryStreamProcessor
        },
        {
            type: StringStreamMarker,
            processor: RecorderDecorators.StringStreamProcessor
        },
        {
            type: Date,
            processor: RecorderDecorators.DateProcessor
        }
    ];
})(RecorderDecorators || (RecorderDecorators = {}));
//# sourceMappingURL=recorder-decorators.js.map