var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { Subscriber, of, isObservable } from 'rxjs';
import { RecorderLogLevel } from '../api/recorder-config';
import { flatMap, map, tap, share, take } from 'rxjs/operators';
import { RecorderManagerDefault } from './recorder-manager-default';
import { flatMapJustOnceRxOpr } from './rxjs-util';
import { LazyRefPrpMarker } from '../api/lazy-ref';
import { TapeActionType } from '../api/tape';
import { TapeActionDefault } from './tape-default';
import { LodashLike } from './lodash-like';
import { LazyRefBase } from './lazy-ref-base';
/**
 * Default implementation!
 * See {@link LazyRef}
 */
var LazyRefPrpDefault = /** @class */ (function (_super) {
    __extends(LazyRefPrpDefault, _super);
    function LazyRefPrpDefault(session) {
        var _this = _super.call(this, session) || this;
        _this.iAmLazyRefPrp = true;
        _this.iAmLazyRefPrpImplementor = true;
        _this._isRealResponseDoneDirectRawWrite = false;
        _this.firstPutOnCacheRef = { value: undefined };
        return _this;
    }
    LazyRefPrpDefault.prototype.isRealResponseDoneDirectRawWrite = function () {
        return this._isRealResponseDoneDirectRawWrite;
    };
    ;
    LazyRefPrpDefault.prototype.setRealResponseDoneDirectRawWrite = function (value) {
        this._isRealResponseDoneDirectRawWrite = value;
    };
    ;
    LazyRefPrpDefault.prototype.setLazyObj = function (lazyLoadedObj, observerOriginal) {
        var _this = this;
        var thisLocal = this;
        //const asyncCombineObsArr: Observable<any>[] = [];
        var fieldEtc = RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(this.session.fielEtcCacheMap, this.refererObj, this.refererKey, this.session.manager.config);
        if (!fieldEtc.propertyOptions) {
            throw new Error('@RecorderDecorators.property() not defined for ' + this.refererObj.constructor.name + '.' + this.refererKey);
        }
        //Validating
        if (!this.refererObj || !this.refererKey) {
            throw new Error('The property \'' + this.refererKey + ' has no refererObj or refererKey' + '. Me:\n' + this);
        }
        if (fieldEtc.prpGenType == null) {
            throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\' is not decorated with com \'@Reflect.metadata("design:generics", GenericTokenizer\'...' + '. Me:\n' + this);
        }
        if (fieldEtc.prpGenType.gType !== LazyRefPrpMarker) {
            throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\' is not LazyRef. Me:\n' + this);
        }
        //null to response.
        this.respObs = null;
        var isValueByFieldProcessor = { value: false };
        if (!this.session.isOnRestoreEntireStateFromLiteral() && !this.isOnLazyLoading) {
            if (!this.session.isRecording()) {
                throw new Error('Invalid operation. It is not recording. Is this Error correct?! Me:\n' + this);
            }
            if (this.lazyLoadedObj !== lazyLoadedObj) {
                if (thisLocal.consoleLike.enabledFor(RecorderLogLevel.Trace)) {
                    thisLocal.consoleLike.group('LazyRefDefault.setLazyObj()' +
                        '(this.lazyLoadedObj === lazyLoadedObj)\n' +
                        'NOT recording action: ' + TapeActionType.SetField + '. actual and new value: ');
                    thisLocal.consoleLike.debug(this.lazyLoadedObj);
                    thisLocal.consoleLike.debug(lazyLoadedObj);
                    thisLocal.consoleLike.groupEnd();
                }
                var mdRefererObj = this.bMdRefererObj;
                var mdLazyLoadedObj = this.bMdLazyLoadedObj;
                //recording tape
                var action_1 = new TapeActionDefault();
                action_1.fieldName = this.refererKey;
                action_1.actionType = TapeActionType.SetField;
                action_1.attachRefId = thisLocal.attachRefId;
                if (mdRefererObj.$signature$) {
                    action_1.ownerSignatureStr = mdRefererObj.$signature$;
                }
                else if (LodashLike.has(this.refererObj, this.session.manager.config.creationIdName)) {
                    action_1.ownerCreationRefId = LodashLike.get(this.refererObj, this.session.manager.config.creationIdName);
                }
                else if (!this.isOnLazyLoading && !mdRefererObj.$isComponentPlayerObjectId$) {
                    throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\' has a not managed owner. Me:\n' + this);
                }
                if (lazyLoadedObj != null) {
                    if (mdLazyLoadedObj.$signature$) {
                        action_1.settedSignatureStr = mdLazyLoadedObj.$signature$;
                    }
                    else if (LodashLike.has(lazyLoadedObj, this.session.manager.config.creationIdName)) {
                        action_1.settedCreationRefId = LodashLike.get(lazyLoadedObj, this.session.manager.config.creationIdName);
                    }
                    else if (fieldEtc.lazyRefMarkerType === LazyRefPrpMarker) {
                        //nothing for now!
                    }
                    else if (!this.isOnLazyLoading) {
                        throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\'.  lazyLoadedObj is not managed: \'' + lazyLoadedObj.constructor.name + '\'' + '. Me:\n' + this);
                    }
                }
                if (fieldEtc.propertyOptions.lazyDirectRawWrite) {
                    isValueByFieldProcessor.value = true;
                    var processTapeActionAttachRefId$ = thisLocal.session.processTapeActionAttachRefId({ fieldEtc: fieldEtc, value: lazyLoadedObj, action: action_1, propertyKey: thisLocal.refererKey });
                    //processTapeActionAttachRefId$ = processTapeActionAttachRefId$.pipe(thisLocal.session.addSubscribedObsRxOpr());
                    processTapeActionAttachRefId$ = processTapeActionAttachRefId$.pipe(thisLocal.mapJustOnceKeepAllFlagsRxOpr(function (ptaariValue) {
                        if (!ptaariValue.asyncAddTapeAction) {
                            thisLocal.session.addTapeAction(action_1);
                        }
                        if (thisLocal.attachRefId !== action_1.attachRefId) {
                            throw new Error('This should not happen');
                        }
                        _this.setLazyObjMayDoNextHelper(isValueByFieldProcessor, fieldEtc, ptaariValue.newValue, observerOriginal);
                        return ptaariValue;
                    }), thisLocal.session.registerProvidedObservablesRxOpr());
                    var subs_1 = processTapeActionAttachRefId$.subscribe(function () {
                        if (subs_1) {
                            subs_1.unsubscribe();
                        }
                    });
                    thisLocal.lazyLoadedObj = null;
                    thisLocal.respObs = of(null).pipe(flatMap(function () {
                        return thisLocal.session.manager.config.cacheHandler.getFromCache(thisLocal.attachRefId);
                    }), map(function (stream) {
                        return { body: stream };
                    }));
                    //asyncCombineObsArr.push(processTapeActionAttachRefId$);
                }
                else if (fieldEtc.fieldProcessorCaller && fieldEtc.fieldProcessorCaller.callToLiteralValue) {
                    isValueByFieldProcessor.value = true;
                    var toLiteralValue$ = fieldEtc.fieldProcessorCaller.callToLiteralValue(action_1.simpleSettedValue, fieldEtc.fieldInfo);
                    // toLiteralValue$ = toLiteralValue$.pipe(this.session.addSubscribedObsRxOpr());
                    toLiteralValue$ = toLiteralValue$.pipe(tap({
                        next: function (value) {
                            action_1.simpleSettedValue = value;
                            thisLocal.session.addTapeAction(action_1);
                        }
                    }), thisLocal.session.registerProvidedObservablesRxOpr(), share());
                    //asyncCombineObsArr.push(toLiteralValue$);
                }
                else {
                    this.session.addTapeAction(action_1);
                }
            }
            else {
                if (thisLocal.consoleLike.enabledFor(RecorderLogLevel.Trace)) {
                    thisLocal.consoleLike.group('LazyRefDefault.setLazyObj()' +
                        '(this.lazyLoadedObj !== lazyLoadedObj)\n' +
                        'Recording action: ' + TapeActionType.SetField + '. value: ');
                    thisLocal.consoleLike.debug(lazyLoadedObj);
                    thisLocal.consoleLike.groupEnd();
                }
            }
        }
        this.setLazyObjMayDoNextHelper(isValueByFieldProcessor, fieldEtc, lazyLoadedObj, observerOriginal);
    };
    LazyRefPrpDefault.prototype.asObservable = function () {
        var _this = this;
        var thisLocal = this;
        var fieldEtc = RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(this.session.fielEtcCacheMap, this.refererObj, this.refererKey, this.session.manager.config);
        if (!fieldEtc.propertyOptions.lazyDirectRawWrite) {
            return _super.prototype.asObservable.call(this);
        }
        else {
            // //providing new readable (flipped) NodeJS.ReadableStream from cache
            // //this.respObs is never null
            // if (!fieldEtc.propertyOptions.lazyDirectRawWrite) {
            //     throw new Error('LazyRefBase.subscribe: thisLocal.attachRefId is not null but this is not lazyDirectRawWrite. Me:\n' +
            //         this);
            // }
            var localObs$ = thisLocal.respObs;
            var localObsL$ = localObs$.pipe(thisLocal.flatMapKeepAllFlagsRxOpr(function (respLikeStream) {
                var processResponseOnLazyLoading = thisLocal.processResponseOnLazyLoading(respLikeStream);
                if (isObservable(processResponseOnLazyLoading)) {
                    var processResponseOnLazyLoading$ = processResponseOnLazyLoading;
                    return processResponseOnLazyLoading$;
                }
                else {
                    return _this.thrownError(new Error('This should not happen soud not happen.This LazyRef is lazyDirectRawWrite'));
                }
            }), 
            //thisLocal.session.registerLazyRefSubscriptionRxOpr(thisLocal.signatureStr),
            thisLocal.session.registerProvidedObservablesRxOpr(), tap({
                next: function () {
                    if (thisLocal.consoleLikeSubs.enabledFor(RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()).');
                        thisLocal.consoleLikeSubs.debug('calling this.next(). attachRefId is not null. Am I using lazyDirectRawWrite? Me:\n' + thisLocal);
                        thisLocal.consoleLikeSubs.groupEnd();
                    }
                }
            }), share());
            return localObsL$;
        }
    };
    LazyRefPrpDefault.prototype.subscribe = function (observerOrNext, error, complete) {
        var thisLocal = this;
        var resultSubs = null;
        var fieldEtc = RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(this.session.fielEtcCacheMap, this.refererObj, this.refererKey, this.session.manager.config);
        if (!fieldEtc.propertyOptions.lazyDirectRawWrite) {
            //super.subscribe() only for non lazyDirectRawWrite
            if (observerOrNext instanceof Subscriber) {
                resultSubs = _super.prototype.subscribe.call(this, observerOrNext);
            }
            else {
                resultSubs = _super.prototype.subscribe.call(this, observerOrNext, error, complete);
            }
        }
        var observerOriginal = this.createAndRegisterObserverOriginal(observerOrNext, error, complete);
        var observerNew = __assign({}, observerOriginal);
        var thisLocalNextOnAsync = { value: false };
        if (thisLocal.lazyLoadedObj == null) {
            if (thisLocal.consoleLikeSubs.enabledFor(RecorderLogLevel.Trace)) {
                thisLocal.consoleLikeSubs.debug('(thisLocal.lazyLoadedObj == null)\n'
                    + 'It may mean that we have not subscribed yet in the Observable of Response');
            }
            if (this.respObs == null) {
                if (thisLocal.consoleLikeSubs.enabledFor(RecorderLogLevel.Trace)) {
                    thisLocal.consoleLikeSubs.debug('(this.respObs == null)\n'
                        + 'Means that we already subscribed to an earlier moment in the Observable of Reponse.\n'
                        + 'We will simply call the super.subscribe and call  next()');
                }
            }
            else if (fieldEtc.propertyOptions.lazyDirectRawWrite) {
                //lazyDirectRawWrite is always readed from cache.
                return this.asObservable().subscribe(observerOriginal, error, complete);
            }
            else {
                if (thisLocal.consoleLikeSubs.enabledFor(RecorderLogLevel.Trace)) {
                    thisLocal.consoleLikeSubs.debug('(thisLocal.respObs != null)\n'
                        + 'Means that we are not subscribed yet in the Observable of Reponse.\n'
                        + 'this.respObs will be null after subscription, so we mark that '
                        + 'there is already an inscription in the Response Observable, and we ' +
                        'will not make two trips to the server');
                }
                //return thisLocal.processResponseOnLazyLoading(response);
                var localObs$ = thisLocal.respObs.pipe(thisLocal.session.logRxOpr('LazyRef_subscribe_respObs'), thisLocal.mapJustOnceKeepAllFlagsRxOpr(function (responseLike) {
                    var processResponseOnLazyLoading = thisLocal.processResponseOnLazyLoading(responseLike);
                    return processResponseOnLazyLoading;
                }));
                thisLocalNextOnAsync.value = true;
                observerNew.next = function (value) {
                    if (thisLocal.consoleLikeSubs.enabledFor(RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => observerNew.next()');
                        thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                        thisLocal.consoleLikeSubs.groupEnd();
                    }
                    thisLocal.setLazyObjOnLazyLoadingNoNext(value);
                    if (!observerNew.closed) {
                        if (thisLocal.consoleLikeSubs.enabledFor(RecorderLogLevel.Trace)) {
                            thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()). !observerNew.closed');
                            thisLocal.consoleLikeSubs.debug('calling this.next()');
                            thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                            thisLocal.consoleLikeSubs.groupEnd();
                        }
                        observerNew.closed = true;
                        //here the original method will be called
                        thisLocal.nextProt(false, thisLocal.lazyLoadedObj, observerOriginal);
                    }
                    else {
                        if (thisLocal.consoleLikeSubs.enabledFor(RecorderLogLevel.Trace)) {
                            thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()). observerNew.closed');
                            thisLocal.consoleLikeSubs.debug('NOT calling this.next()');
                            thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                            thisLocal.consoleLikeSubs.groupEnd();
                        }
                    }
                };
                thisLocalNextOnAsync.value = true;
                localObs$ = localObs$.pipe(thisLocal.session.registerLazyRefSubscriptionRxOpr(thisLocal.signatureStr), thisLocal.session.registerProvidedObservablesRxOpr(), tap(function () {
                    //so we will mark that you already hear an entry in the Response Observable, and we will not make two trips to the server.
                    //lazyDirectRawWrite is always readed from cache.
                    if (!fieldEtc.propertyOptions.lazyDirectRawWrite) {
                        thisLocal.respObs = null;
                    }
                }), share());
                localObs$.subscribe(observerNew);
            }
        }
        else {
            if (fieldEtc.propertyOptions.lazyDirectRawRead) {
                //providing new readable (flipped) NodeJS.ReadableStream from cache
                if (thisLocal.attachRefId) {
                    throw new Error('LazyRefBase.subscribe: thisLocal.attachRefId must be null when this.lazyLoadedObj is not null. Me:\n' +
                        this);
                }
                thisLocalNextOnAsync.value = true;
                var getFromCache$ = this.session.manager.config.cacheHandler.getFromCache(this.attachRefId);
                var fromDirectRaw$ = getFromCache$
                    .pipe(flatMapJustOnceRxOpr(function (stream) {
                    return fieldEtc.fieldProcessorCaller.callFromDirectRaw(of({
                        body: stream,
                    }), fieldEtc.fieldInfo);
                }), map(function (respL) {
                    return respL;
                }));
                // fromDirectRaw$ = fromDirectRaw$.pipe(thisLocal.session.addSubscribedObsRxOpr());
                fromDirectRaw$ = fromDirectRaw$.pipe(tap({
                    next: function (repValue) {
                        thisLocal.setLazyObjOnLazyLoadingNoNext(repValue.body);
                        if (!observerNew.closed) {
                            if (thisLocal.consoleLikeSubs.enabledFor(RecorderLogLevel.Trace)) {
                                thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()). !observerNew.closed');
                                thisLocal.consoleLikeSubs.debug('calling this.next()');
                                thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                                thisLocal.consoleLikeSubs.groupEnd();
                            }
                            observerNew.closed = true;
                            thisLocal.nextProt(true, thisLocal.lazyLoadedObj, observerOriginal);
                        }
                        else {
                            if (thisLocal.consoleLikeSubs.enabledFor(RecorderLogLevel.Trace)) {
                                thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()). observerNew.closed');
                                thisLocal.consoleLikeSubs.debug('NOT calling this.next()');
                                thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                                thisLocal.consoleLikeSubs.groupEnd();
                            }
                        }
                    },
                    error: observerNew.error,
                    complete: observerNew.complete,
                    closed: observerNew.closed
                }));
                fromDirectRaw$ = fromDirectRaw$.pipe(thisLocal.session.registerProvidedObservablesRxOpr(), take(1));
                fromDirectRaw$.subscribe(function () {
                    //thisLocal.nextPriv(respValue.body);
                    //nothing
                });
            }
        }
        if (thisLocal.consoleLikeSubs.enabledFor(RecorderLogLevel.Trace)) {
            thisLocal.consoleLikeSubs.debug('(thisLocal.lazyLoadedObj != null)\n'
                + 'It may mean that we already have subscribed yet in the Observable of Response\n '
                + 'or this was created with lazyLoadedObj already loaded.');
        }
        if (!observerNew.closed && !thisLocalNextOnAsync.value) {
            thisLocal.nextProt(false, thisLocal.lazyLoadedObj, observerOriginal);
        }
        return resultSubs;
    };
    LazyRefPrpDefault.prototype.processResponse = function (responselike) {
        var _this = this;
        var thisLocal = this;
        //const asyncCombineObsArr: Observable<any>[] = [];
        var lazyLoadedObj$;
        var isLazyRefOfCollection = false;
        var mdRefererObj = { $iAmPlayerMetadatas$: true };
        var fieldEtc = RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(this.session.fielEtcCacheMap, this.refererObj, this.refererKey, this.session.manager.config);
        if (!fieldEtc.propertyOptions.lazyDirectRawWrite) {
            thisLocal.session.validatePlayerSideResponseLike(responselike);
        }
        var playerSnapshot;
        playerSnapshot = responselike.body;
        if (LodashLike.has(this.refererObj, this.session.manager.config.playerMetadatasName)) {
            mdRefererObj = LodashLike.get(this.refererObj, this.session.manager.config.playerMetadatasName);
        }
        if (this.genericNode.gType !== LazyRefPrpMarker) {
            throw new Error('Wrong type: ' + this.genericNode.gType.name + '. Me:\n' + this);
        }
        var isResponseBodyStream = fieldEtc.propertyOptions.lazyDirectRawWrite
            || (responselike.body.pipe && responselike.body);
        if (this.lazyLoadedObj == null) {
            if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: LazyRef.lazyLoadedObj is not setted yet: Me:\n' + this);
            }
            if (fieldEtc.propertyOptions.lazyDirectRawRead && isResponseBodyStream) {
                if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                    thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: LazyRefPrp is "lazyDirectRawRead". Me:\n' + this);
                }
                if (!isResponseBodyStream) {
                    throw new Error('LazyRefBase.processResponse: LazyRefPrp is "lazyDirectRawRead" but "responselike.body" is not a NodeJS.ReadableStream. Me:\n' +
                        this + '\nresponselike.body.constructor.name: ' +
                        (responselike && responselike.body && responselike.body.constructor.name ? responselike.body.constructor.name : 'null'));
                }
                if (fieldEtc.propertyOptions.lazyDirectRawWrite) {
                    thisLocal.lazyLoadedObj = null;
                    //setting next respObs
                    if (!LodashLike.isNil(responselike.body)) {
                        thisLocal.respObs = of(null).pipe(flatMap(function () {
                            return thisLocal.firstPutOnCacheRef.value ?
                                thisLocal.firstPutOnCacheRef.value :
                                of(null);
                        }), flatMap(function () {
                            return thisLocal.session.manager.config.cacheHandler.getFromCache(thisLocal.attachRefId);
                        }), map(function (stream) {
                            return { body: stream };
                        }));
                    }
                    else {
                        thisLocal.firstPutOnCacheRef.value = undefined;
                        thisLocal.setRealResponseDoneDirectRawWrite(true);
                        thisLocal.respObs = of({ body: null });
                    }
                    var putOnCache$ = void 0;
                    var isRealResponseDoneDirectRawWriteLocal = thisLocal.isRealResponseDoneDirectRawWrite();
                    if (!isRealResponseDoneDirectRawWriteLocal) {
                        thisLocal.attachRefId = this.session.manager.config.cacheStoragePrefix + this.session.nextMultiPurposeInstanceId().toString();
                        if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                            thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: fieldEtc.propertyOptions.lazyDirectRawWrite.' +
                                ' (!thisLocal.isOriginalResponseDone()). There is no value yet on CacheHandler!"\n' + this);
                        }
                        thisLocal._isRealResponseDoneDirectRawWrite = true;
                        putOnCache$ = this.session.manager.config.cacheHandler.putOnCache(thisLocal.attachRefId, responselike.body).pipe(tap(function () {
                            thisLocal.firstPutOnCacheRef.value = undefined;
                        }));
                        thisLocal.firstPutOnCacheRef.value = putOnCache$;
                    }
                    else {
                        if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                            thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: fieldEtc.propertyOptions.lazyDirectRawWrite.' +
                                '(thisLocal.isOriginalResponseDone()). Already have value on CacheHandler or responselike.body is null!"\n' + this);
                        }
                        putOnCache$ = of(undefined);
                    }
                    var getFromCache$ = void 0;
                    if (!isRealResponseDoneDirectRawWriteLocal) {
                        getFromCache$ = putOnCache$.pipe(share(), flatMap(function () {
                            return thisLocal.session.manager.config.cacheHandler.getFromCache(thisLocal.attachRefId);
                        }));
                    }
                    else {
                        // in this case responselike.body already is from the cache!
                        getFromCache$ = of(responselike.body);
                    }
                    var afterGetFromCache$ = void 0;
                    if (!fieldEtc.fieldProcessorCaller.callFromDirectRaw) {
                        afterGetFromCache$ = putOnCache$.pipe(map(function () {
                            return responselike.body;
                        }));
                    }
                    else {
                        afterGetFromCache$ = getFromCache$.pipe(flatMap(function (respStream) {
                            return fieldEtc.fieldProcessorCaller.callFromDirectRaw(of({ body: respStream }), fieldEtc.fieldInfo);
                        }), map(function (respL) {
                            return respL.body;
                        }));
                    }
                    if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: fieldEtc.propertyOptions.lazyDirectRawWrite.' +
                            ' thisLocal.lazyLoadedObj will never be setted, value will be always obtained from CacheHandler!"\n' + this);
                    }
                    return afterGetFromCache$;
                }
                else if (fieldEtc.fieldProcessorCaller.callFromDirectRaw) {
                    if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: LazyRefPrp is "lazyDirectRawRead" and has "IFieldProcessor.fromDirectRaw".');
                    }
                    var fromDirectRaw$ = fieldEtc.fieldProcessorCaller.callFromDirectRaw(of(responselike), fieldEtc.fieldInfo);
                    lazyLoadedObj$ =
                        fromDirectRaw$
                            .pipe(thisLocal.mapJustOnceKeepAllFlagsRxOpr(function (respL) {
                            if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                                thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: Async on "IFieldProcessor.fromDirectRaw" result. Me:\n' + _this);
                            }
                            thisLocal.setLazyObjOnLazyLoadingNoNext(respL.body);
                            return _this.lazyLoadedObj;
                        }));
                    lazyLoadedObj$ = lazyLoadedObj$.pipe(thisLocal.session.registerProvidedObservablesRxOpr(), share());
                    return lazyLoadedObj$;
                }
                else {
                    if (Object.getOwnPropertyNames(fieldEtc.lazyLoadedObjType).lastIndexOf('pipe') < 0) {
                        throw new Error('LazyRefBase.processResponse: LazyRefPrp is "lazyDirectRawRead" and has no "IFieldProcessor.fromDirectRaw",' +
                            ' but this generic definition is LazyRepPrp<' + (fieldEtc.lazyLoadedObjType ? fieldEtc.lazyLoadedObjType.name : '') + '>. Me:\n' +
                            this);
                    }
                    if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: LazyRef is "lazyDirectRawRead" and has NO "IFieldProcessor.fromDirectRaw". Using "responselike.body"');
                    }
                }
            }
            else if ((!fieldEtc.propertyOptions.lazyDirectRawRead)
                || (fieldEtc.propertyOptions.lazyDirectRawRead && !isResponseBodyStream)) {
                if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Warn)) {
                    thisLocal.consoleLikeProcResp.warn('LazyRefBase.processResponse: (LazyRefPrp is NOT "lazyDirectRawRead") or ' +
                        '(LazyRefPrp is "lazyDirectRawRead" and "responseLike.body" is not a NodeJS.ReadableStream). Is it rigth?! Me:\n' + this);
                }
                if (fieldEtc.fieldProcessorCaller.callFromLiteralValue) {
                    if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: ((LazyRefPrp is NOT "lazyDirectRawRead") or (...above...)) and has "IFieldProcessor.fromLiteralValue".');
                    }
                    var fromLiteralValue = fieldEtc.fieldProcessorCaller.callFromLiteralValue(responselike.body, fieldEtc.fieldInfo);
                    if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: Async on "IFieldProcessor.fromLiteralValue" result. Me:\n' + this);
                    }
                    thisLocal.lazyRefPrpStoreOriginalliteralEntryIfNeeded(mdRefererObj, fieldEtc, playerSnapshot);
                    thisLocal.setLazyObjOnLazyLoadingNoNext(fromLiteralValue);
                }
                else {
                    if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: ((LazyRefPrp is NOT "lazyDirectRawRead") or (...above...)) and has NO "IFieldProcessor.fromLiteralValue". Using "responselike.body"');
                    }
                    this.setLazyObjOnLazyLoadingNoNext(responselike.body);
                }
            }
            else {
                throw new Error('ot supportted: lazyDirectRawRead: ' +
                    fieldEtc.propertyOptions.lazyDirectRawRead +
                    '; isResponseBodyStream: ' +
                    isResponseBodyStream +
                    '. Me:\n' + this);
            }
        }
        if (this.signatureStr && !lazyLoadedObj$) {
            if (!this.session.isOnRestoreEntireStateFromLiteral()) {
                if (!mdRefererObj.$signature$ && !mdRefererObj.$isComponentPlayerObjectId$) {
                    throw new Error('The referer object has no mdRefererObj.$signature$. This should not happen. Me:\n' + this);
                }
                else {
                    if (isLazyRefOfCollection) {
                    }
                }
                if (!mdRefererObj.$signature$) {
                    if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: (!mdRefererObj.$signature$): owner entity not found for LazyRef, the owner must be a player side component. Me:\n' + this);
                    }
                }
            }
            if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: IS LazyRefPrp, NOT keeping reference by signature. Me:\n' + this);
            }
        }
        if (lazyLoadedObj$) {
            lazyLoadedObj$ = lazyLoadedObj$.pipe(thisLocal.mapJustOnceKeepAllFlagsRxOpr(function (lazyLoadedObjValueB) {
                if (thisLocal.respObs && thisLocal.session.isOnRestoreEntireStateFromLiteral()) {
                    if (thisLocal.consoleLikeProcResp.enabledFor(RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeProcResp.group('LazyRefBase.processResponse: changing "this.respObs"' +
                            ' to null because "this.session.isOnRestoreEntireStateFromLiteral()"\n' + _this);
                        thisLocal.consoleLikeProcResp.debug(thisLocal.lazyLoadedObj);
                        thisLocal.consoleLikeProcResp.groupEnd();
                    }
                }
                return lazyLoadedObjValueB;
            }), thisLocal.session.registerProvidedObservablesRxOpr(), map(function (lazyLoadedObjValueC) {
                return lazyLoadedObjValueC;
            }), share()),
                lazyLoadedObj$.subscribe(function (lazyLoadedObj) {
                    thisLocal.respObs = null;
                    _this.setLazyObjOnLazyLoadingNoNext(lazyLoadedObj);
                });
        }
        return thisLocal.lazyLoadedObj;
    };
    return LazyRefPrpDefault;
}(LazyRefBase));
export { LazyRefPrpDefault };
//# sourceMappingURL=lazy-ref-prp-default.js.map