import { Observable } from "rxjs";
import { TypeLike } from "../typeslike";
export declare namespace LodashLike {
    type Diff<T, U> = T extends U ? never : T;
    type NonObservable<T> = Diff<T, Observable<T>>;
    interface AsyncMergeWithCustomizerResult<T> {
        value: NonObservable<T>;
        needSet: boolean;
    }
    type AsyncMergeWithCustomizer = {
        bivariantHack(value: any, srcValue: any, key: string, object: any, source: any): AsyncMergeWithCustomizerResult<any>;
    }["bivariantHack"];
    type MergeWithCustomizer = {
        bivariantHack(value: any, srcValue: any, key: string, object: any, source: any): any;
    }["bivariantHack"];
    function isObject(value: any, noObjects?: Set<TypeLike<any>>): boolean;
    function isNil(value: any): boolean;
    function mergeWith<TObject, TSource>(object: TObject, source: TSource, customizer: MergeWithCustomizer, noObjects?: Set<TypeLike<any>>): TObject;
    interface AsyncMergeWithExtraOptions {
        customizer?: AsyncMergeWithCustomizer;
        noObjects?: Set<TypeLike<any>>;
        considerObjectProperties?: boolean;
        ignorePropeties?: RegExp[];
    }
    function asyncMergeWith<TObject, TSource>(object: TObject, source: TSource, extraOptions?: AsyncMergeWithExtraOptions): TObject;
    function has(obj: any, prop: string): boolean;
    function get<T>(obj: any, prop: string): T;
    function set(obj: any, prop: string, value: any): void;
    function clone(source: any, noObjects?: Set<TypeLike<any>>): any;
    function keys(object: any): string[];
    function isArrayLike(value: any): boolean;
}
