import { of, from } from "rxjs";
import { map } from "rxjs/operators";
import { flatMapJustOnceRxOpr, combineFirstSerial } from "./rxjs-util";
var toStream = require('blob-to-stream');
var toBlob = require('stream-to-blob');
export var RecorderForDom;
(function (RecorderForDom) {
    RecorderForDom.CacheHandlerDefault = {
        clearCache: function () {
            return from(caches.open('jshb_cachestorage'))
                .pipe(map(function (cache) {
                return from(cache.keys())
                    .pipe(flatMapJustOnceRxOpr(function (requests) {
                    var obsArr = [];
                    for (var _i = 0, requests_1 = requests; _i < requests_1.length; _i++) {
                        var req = requests_1[_i];
                        obsArr.push(from(cache.delete(req)));
                    }
                    if (obsArr.length > 0) {
                        return combineFirstSerial(obsArr);
                    }
                    else {
                        return of(null);
                    }
                }));
            }))
                .pipe(map(function () { }));
        },
        getFromCache: function (cacheKey) {
            return from(caches.open('jshb_cachestorage'))
                .pipe(flatMapJustOnceRxOpr(function (cache) {
                return from(cache.match(cacheKey));
            }))
                .pipe(flatMapJustOnceRxOpr(function (response) {
                return from(response.blob());
            }))
                .pipe(flatMapJustOnceRxOpr(function (blob) {
                return of(toStream(blob));
            }));
        },
        putOnCache: function (cacheKey, stream) {
            return from(caches.open('jshb_cachestorage'))
                .pipe(map(function (cache) {
                return from(cache.put(cacheKey, new Response(toBlob(stream), null)))
                    .pipe(map(function () { }));
            }))
                .pipe(map(function () { }));
        },
        removeFromCache: function (cacheKey) {
            return from(caches.open('jshb_cachestorage'))
                .pipe(map(function (cache) {
                return from(cache.delete(cacheKey))
                    .pipe(map(function () { }));
            }))
                .pipe(map(function () { }));
        }
    };
})(RecorderForDom || (RecorderForDom = {}));
//# sourceMappingURL=native-for-dom.js.map