/// <reference types="node" />
import { Observable, Subscription, PartialObserver } from 'rxjs';
import { ResponseLike } from '../typeslike';
import { LazyRefOTM } from '../api/lazy-ref';
import { PlayerSnapshot, RecorderSessionImplementor } from '../api/recorder-session';
import { LazyRefBase } from './lazy-ref-base';
/**
 * Default implementation!
 * See {@link LazyRef}
 */
export declare class LazyRefOTMDefault<L extends object> extends LazyRefBase<L, undefined> implements LazyRefOTM<L> {
    iAmLazyRefOTM: true;
    constructor(session: RecorderSessionImplementor);
    setLazyObj(lazyLoadedObj: L, observerOriginal?: PartialObserver<L>): void;
    asObservable(): Observable<L>;
    subscribe(observerOrNext?: PartialObserver<L> | ((value: L) => void), error?: (error: any) => void, complete?: () => void): Subscription;
    processResponse(responselike: ResponseLike<PlayerSnapshot | NodeJS.ReadStream>): L | Observable<L>;
}
