/// <reference types="node" />
import { Observable, Subscription, PartialObserver } from 'rxjs';
import { ResponseLike } from '../typeslike';
import { LazyRefPrpImplementor } from '../api/lazy-ref';
import { LazyRefBase } from './lazy-ref-base';
import { RecorderSessionImplementor, PlayerSnapshot } from '../api/recorder-session';
/**
 * Default implementation!
 * See {@link LazyRef}
 */
export declare class LazyRefPrpDefault<L extends object> extends LazyRefBase<L, undefined> implements LazyRefPrpImplementor<L> {
    iAmLazyRefPrp: true;
    iAmLazyRefPrpImplementor: true;
    constructor(session: RecorderSessionImplementor);
    private _isRealResponseDoneDirectRawWrite;
    isRealResponseDoneDirectRawWrite(): boolean;
    setRealResponseDoneDirectRawWrite(value: boolean): void;
    setLazyObj(lazyLoadedObj: L, observerOriginal?: PartialObserver<L>): void;
    asObservable(): Observable<L>;
    subscribe(observerOrNext?: PartialObserver<L> | ((value: L) => void), error?: (error: any) => void, complete?: () => void): Subscription;
    private firstPutOnCacheRef;
    processResponse(responselike: ResponseLike<PlayerSnapshot | NodeJS.ReadStream>): L | Observable<L>;
}
