(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../implementation/recorder-decorators-internal", "./lazy-ref"], factory);
    }
})(function (require, exports) {
    Object.defineProperty(exports, "__esModule", { value: true });
    var recorder_decorators_internal_1 = require("../implementation/recorder-decorators-internal");
    var lazy_ref_1 = require("./lazy-ref");
    var RecorderDecorators;
    (function (RecorderDecorators) {
        function property() {
            var options = { persistent: true };
            if (arguments.length > 0) {
                options = arguments[0];
            }
            return recorder_decorators_internal_1.RecorderDecoratorsInternal.property(options);
        }
        RecorderDecorators.property = property;
        function playerObjectId() {
            return recorder_decorators_internal_1.RecorderDecoratorsInternal.playerObjectId();
        }
        RecorderDecorators.playerObjectId = playerObjectId;
        /**
         * Decorator for persistent entity.
         *
         * Sample:
         * ```ts
         * ...
         * @JsonPlayback.playerType({playerType: 'org.mypackage.MyPersistentEntity'})
         * export class MyPersistentEntityJs {
         * ...
         * ```
         */
        function playerType(options) {
            return recorder_decorators_internal_1.RecorderDecoratorsInternal.playerType(options);
        }
        RecorderDecorators.playerType = playerType;
        RecorderDecorators.DateProcessor = recorder_decorators_internal_1.RecorderDecoratorsInternal.DateProcessor;
        RecorderDecorators.BufferProcessor = recorder_decorators_internal_1.RecorderDecoratorsInternal.BufferProcessor;
        RecorderDecorators.StringProcessor = recorder_decorators_internal_1.RecorderDecoratorsInternal.StringProcessor;
        RecorderDecorators.BinaryStreamProcessor = recorder_decorators_internal_1.RecorderDecoratorsInternal.BinaryStreamProcessor;
        RecorderDecorators.StringStreamProcessor = recorder_decorators_internal_1.RecorderDecoratorsInternal.StringStreamProcessor;
        RecorderDecorators.TypeProcessorEntries = [
            {
                type: Buffer,
                processor: RecorderDecorators.BufferProcessor
            },
            {
                type: String,
                processor: RecorderDecorators.StringProcessor
            },
            {
                type: lazy_ref_1.BinaryStreamMarker,
                processor: RecorderDecorators.BinaryStreamProcessor
            },
            {
                type: lazy_ref_1.StringStreamMarker,
                processor: RecorderDecorators.StringStreamProcessor
            },
            {
                type: Date,
                processor: RecorderDecorators.DateProcessor
            }
        ];
    })(RecorderDecorators = exports.RecorderDecorators || (exports.RecorderDecorators = {}));
});
//# sourceMappingURL=recorder-decorators.js.map