/// <reference types="node" />
import { Observable, Subscription, PartialObserver } from 'rxjs';
import { ResponseLike } from '../typeslike';
import { LazyRefMTOImplementor } from '../api/lazy-ref';
import { RecorderSessionImplementor, PlayerSnapshot } from '../api/recorder-session';
import { LazyRefBase } from './lazy-ref-base';
/**
 * Default implementation!
 * See {@link LazyRef}
 */
export declare class LazyRefMTODefault<L extends object, I> extends LazyRefBase<L, I> implements LazyRefMTOImplementor<L, I> {
    iAmLazyRefMTO: true;
    iAmLazyRefMTOImplementor: true;
    constructor(session: RecorderSessionImplementor);
    setLazyObj(lazyLoadedObj: L, observerOriginal?: PartialObserver<L>): void;
    asObservable(): Observable<L>;
    subscribe(observerOrNext?: PartialObserver<L> | ((value: L) => void), error?: (error: any) => void, complete?: () => void): Subscription;
    processResponse(responselike: ResponseLike<PlayerSnapshot | NodeJS.ReadStream>): L | Observable<L>;
    private _playerObjectId;
    playerObjectId: I;
}
