var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "rxjs", "../api/recorder-config", "rxjs/operators", "./recorder-manager-default", "./rxjs-util", "../api/lazy-ref", "../api/tape", "./tape-default", "./lodash-like", "./lazy-ref-base"], factory);
    }
})(function (require, exports) {
    Object.defineProperty(exports, "__esModule", { value: true });
    var rxjs_1 = require("rxjs");
    var recorder_config_1 = require("../api/recorder-config");
    var operators_1 = require("rxjs/operators");
    var recorder_manager_default_1 = require("./recorder-manager-default");
    var rxjs_util_1 = require("./rxjs-util");
    var lazy_ref_1 = require("../api/lazy-ref");
    var tape_1 = require("../api/tape");
    var tape_default_1 = require("./tape-default");
    var lodash_like_1 = require("./lodash-like");
    var lazy_ref_base_1 = require("./lazy-ref-base");
    /**
     * Default implementation!
     * See {@link LazyRef}
     */
    var LazyRefMTODefault = /** @class */ (function (_super) {
        __extends(LazyRefMTODefault, _super);
        function LazyRefMTODefault(session) {
            var _this = _super.call(this, session) || this;
            _this.iAmLazyRefMTO = true;
            _this.iAmLazyRefMTOImplementor = true;
            return _this;
        }
        LazyRefMTODefault.prototype.setLazyObj = function (lazyLoadedObj, observerOriginal) {
            var thisLocal = this;
            //const asyncCombineObsArr: Observable<any>[] = [];
            var fieldEtc = recorder_manager_default_1.RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(this.session.fielEtcCacheMap, this.refererObj, this.refererKey, this.session.manager.config);
            if (!fieldEtc.propertyOptions) {
                throw new Error('@RecorderDecorators.property() not defined for ' + this.refererObj.constructor.name + '.' + this.refererKey);
            }
            //Validating
            if (!this.refererObj || !this.refererKey) {
                throw new Error('The property \'' + this.refererKey + ' has no refererObj or refererKey' + '. Me:\n' + this);
            }
            if (fieldEtc.prpGenType == null) {
                throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\' is not decorated with com \'@Reflect.metadata("design:generics", GenericTokenizer\'...' + '. Me:\n' + this);
            }
            if (fieldEtc.prpGenType.gType !== lazy_ref_1.LazyRefMTOMarker) {
                throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\' is not LazyRef. Me:\n' + this);
            }
            //null to response.
            this.respObs = null;
            var isValueByFieldProcessor = { value: false };
            if (!this.session.isOnRestoreEntireStateFromLiteral() && !this.isOnLazyLoading) {
                if (!this.session.isRecording()) {
                    throw new Error('Invalid operation. It is not recording. Is this Error correct?! Me:\n' + this);
                }
                if (this.lazyLoadedObj !== lazyLoadedObj) {
                    if (thisLocal.consoleLike.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                        thisLocal.consoleLike.group('LazyRefDefault.setLazyObj()' +
                            '(this.lazyLoadedObj === lazyLoadedObj)\n' +
                            'NOT recording action: ' + tape_1.TapeActionType.SetField + '. actual and new value: ');
                        thisLocal.consoleLike.debug(this.lazyLoadedObj);
                        thisLocal.consoleLike.debug(lazyLoadedObj);
                        thisLocal.consoleLike.groupEnd();
                    }
                    var mdRefererObj = this.bMdRefererObj;
                    var mdLazyLoadedObj = this.bMdLazyLoadedObj;
                    //recording tape
                    var action = new tape_default_1.TapeActionDefault();
                    action.fieldName = this.refererKey;
                    action.actionType = tape_1.TapeActionType.SetField;
                    action.attachRefId = thisLocal.attachRefId;
                    if (mdRefererObj.$signature$) {
                        action.ownerSignatureStr = mdRefererObj.$signature$;
                    }
                    else if (lodash_like_1.LodashLike.has(this.refererObj, this.session.manager.config.creationIdName)) {
                        action.ownerCreationRefId = lodash_like_1.LodashLike.get(this.refererObj, this.session.manager.config.creationIdName);
                    }
                    else if (!this.isOnLazyLoading && !mdRefererObj.$isComponentPlayerObjectId$) {
                        throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\' has a not managed owner. Me:\n' + this);
                    }
                    if (lazyLoadedObj != null) {
                        if (mdLazyLoadedObj.$signature$) {
                            action.settedSignatureStr = mdLazyLoadedObj.$signature$;
                        }
                        else if (lodash_like_1.LodashLike.has(lazyLoadedObj, this.session.manager.config.creationIdName)) {
                            action.settedCreationRefId = lodash_like_1.LodashLike.get(lazyLoadedObj, this.session.manager.config.creationIdName);
                        }
                        else if (fieldEtc.lazyRefMarkerType === lazy_ref_1.LazyRefPrpMarker) {
                            //nothing for now!
                        }
                        else if (!this.isOnLazyLoading) {
                            throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\'.  lazyLoadedObj is not managed: \'' + lazyLoadedObj.constructor.name + '\'' + '. Me:\n' + this);
                        }
                    }
                }
                else {
                    if (thisLocal.consoleLike.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                        thisLocal.consoleLike.group('LazyRefDefault.setLazyObj()' +
                            '(this.lazyLoadedObj !== lazyLoadedObj)\n' +
                            'Recording action: ' + tape_1.TapeActionType.SetField + '. value: ');
                        thisLocal.consoleLike.debug(lazyLoadedObj);
                        thisLocal.consoleLike.groupEnd();
                    }
                }
            }
            if (!isValueByFieldProcessor.value && fieldEtc.prpGenType.gType !== lazy_ref_1.LazyRefPrpMarker) {
                if (this.lazyLoadedObj !== lazyLoadedObj) {
                    if (this.lazyLoadedObj) {
                        this.session.unregisterEntityAndLazyref(this.lazyLoadedObj, this);
                    }
                }
            }
            else {
            }
            this.setLazyObjMayDoNextHelper(isValueByFieldProcessor, fieldEtc, lazyLoadedObj, observerOriginal);
        };
        LazyRefMTODefault.prototype.asObservable = function () {
            var _this = this;
            var thisLocal = this;
            var fieldEtc = recorder_manager_default_1.RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(this.session.fielEtcCacheMap, this.refererObj, this.refererKey, this.session.manager.config);
            if (!fieldEtc.propertyOptions.lazyDirectRawWrite) {
                return _super.prototype.asObservable.call(this);
            }
            else {
                //providing new readable (flipped) NodeJS.ReadableStream from cache
                //this.respObs is never null
                if (!fieldEtc.propertyOptions.lazyDirectRawWrite) {
                    throw new Error('LazyRefMTODefault.subscribe: thisLocal.attachRefId is not null but this is not lazyDirectRawWrite. Me:\n' +
                        this);
                }
                var localObs$ = thisLocal.respObs;
                var localObsL$ = localObs$.pipe(thisLocal.flatMapKeepAllFlagsRxOpr(function (respLikeStream) {
                    var processResponseOnLazyLoading = thisLocal.processResponseOnLazyLoading(respLikeStream);
                    if (rxjs_1.isObservable(processResponseOnLazyLoading)) {
                        var processResponseOnLazyLoading$ = processResponseOnLazyLoading;
                        return processResponseOnLazyLoading$;
                    }
                    else {
                        return _this.thrownError(new Error('This should not happen soud not happen.This LazyRef is lazyDirectRawWrite'));
                    }
                }), 
                //thisLocal.session.registerLazyRefSubscriptionRxOpr(thisLocal.signatureStr),
                thisLocal.session.registerProvidedObservablesRxOpr(), operators_1.tap({
                    next: function () {
                        if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                            thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()).');
                            thisLocal.consoleLikeSubs.debug('calling this.next(). attachRefId is not null. Am I using lazyDirectRawWrite? Me:\n' + thisLocal);
                            thisLocal.consoleLikeSubs.groupEnd();
                        }
                    }
                }), operators_1.share());
                return localObsL$;
            }
        };
        LazyRefMTODefault.prototype.subscribe = function (observerOrNext, error, complete) {
            var thisLocal = this;
            var resultSubs = null;
            var fieldEtc = recorder_manager_default_1.RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(this.session.fielEtcCacheMap, this.refererObj, this.refererKey, this.session.manager.config);
            if (fieldEtc.propertyOptions.lazyDirectRawWrite) {
                throw new Error('lazyDirectRawWrite can not be used with LazyRefMTO');
            }
            if (fieldEtc.propertyOptions.lazyDirectRawRead) {
                throw new Error('lazyDirectRawRead can not be used with LazyRefMTO');
            }
            //super.subscribe() only for non lazyDirectRawWrite
            if (observerOrNext instanceof rxjs_1.Subscriber) {
                resultSubs = _super.prototype.subscribe.call(this, observerOrNext);
            }
            else {
                resultSubs = _super.prototype.subscribe.call(this, observerOrNext, error, complete);
            }
            var observerOriginal = this.createAndRegisterObserverOriginal(observerOrNext, error, complete);
            var observerNew = __assign({}, observerOriginal);
            var thisLocalNextOnAsync = { value: false };
            if (thisLocal.lazyLoadedObj == null) {
                if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                    thisLocal.consoleLikeSubs.debug('(thisLocal.lazyLoadedObj == null)\n'
                        + 'It may mean that we have not subscribed yet in the Observable of Response');
                }
                if (this.respObs == null) {
                    if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeSubs.debug('(this.respObs == null)\n'
                            + 'Means that we already subscribed to an earlier moment in the Observable of Reponse.\n'
                            + 'We will simply call the super.subscribe and call  next()');
                    }
                }
                else if (this.session.getCachedBySignature(this.signatureStr)) {
                    if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeSubs.debug('(this.lazyLoadedObj == null && this.respObs != null && this.session.getCachedBySignature(this.signatureStr)\n'
                            + 'Means that we already loaded this object by signature with another lazyRef.\n'
                            + 'We will get from session signature cache call next()');
                    }
                    thisLocalNextOnAsync.value = true;
                    thisLocal.setLazyObjOnLazyLoading(this.session.getCachedBySignature(this.signatureStr), observerOriginal);
                    if (!observerNew.closed) {
                        observerNew.closed = true;
                        if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                            thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()). !observerNew.closed');
                            thisLocal.consoleLikeSubs.debug('calling this.next()');
                            thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                            thisLocal.consoleLikeSubs.groupEnd();
                        }
                        //here the original method will be called
                        thisLocal.respObs = null;
                        thisLocal.nextProt(false, thisLocal.lazyLoadedObj, observerOriginal);
                    }
                    else {
                        if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                            thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()). observerNew.closed');
                            thisLocal.consoleLikeSubs.debug('NOT calling this.next()');
                            thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                            thisLocal.consoleLikeSubs.groupEnd();
                        }
                    }
                }
                else if (fieldEtc.propertyOptions.lazyDirectRawWrite) {
                    //lazyDirectRawWrite is always readed from cache.
                    return this.asObservable().subscribe(observerOriginal, error, complete);
                }
                else {
                    if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeSubs.debug('(thisLocal.respObs != null)\n'
                            + 'Means that we are not subscribed yet in the Observable of Reponse.\n'
                            + 'this.respObs will be null after subscription, so we mark that '
                            + 'there is already an inscription in the Response Observable, and we ' +
                            'will not make two trips to the server');
                    }
                    //return thisLocal.processResponseOnLazyLoading(response);
                    var localObs$ = thisLocal.respObs.pipe(thisLocal.session.logRxOpr('LazyRef_subscribe_respObs'), thisLocal.mapJustOnceKeepAllFlagsRxOpr(function (responseLike) {
                        var processResponseOnLazyLoading = thisLocal.processResponseOnLazyLoading(responseLike);
                        return processResponseOnLazyLoading;
                    }));
                    thisLocalNextOnAsync.value = true;
                    observerNew.next = function (value) {
                        if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                            thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => observerNew.next()');
                            thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                            thisLocal.consoleLikeSubs.groupEnd();
                        }
                        thisLocal.setLazyObjOnLazyLoadingNoNext(value);
                        if (!observerNew.closed) {
                            if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                                thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()). !observerNew.closed');
                                thisLocal.consoleLikeSubs.debug('calling this.next()');
                                thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                                thisLocal.consoleLikeSubs.groupEnd();
                            }
                            observerNew.closed = true;
                            //here the original method will be called
                            thisLocal.nextProt(false, thisLocal.lazyLoadedObj, observerOriginal);
                        }
                        else {
                            if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                                thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()). observerNew.closed');
                                thisLocal.consoleLikeSubs.debug('NOT calling this.next()');
                                thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                                thisLocal.consoleLikeSubs.groupEnd();
                            }
                        }
                    };
                    thisLocalNextOnAsync.value = true;
                    localObs$ = localObs$.pipe(thisLocal.session.registerLazyRefSubscriptionRxOpr(thisLocal.signatureStr), thisLocal.session.registerProvidedObservablesRxOpr(), operators_1.tap(function () {
                        //so we will mark that you already hear an entry in the Response Observable, and we will not make two trips to the server.
                        //lazyDirectRawWrite is always readed from cache.
                        if (!fieldEtc.propertyOptions.lazyDirectRawWrite) {
                            thisLocal.respObs = null;
                        }
                    }), operators_1.share());
                    localObs$.subscribe(observerNew);
                }
            }
            else {
                if (fieldEtc.prpGenType.gType === lazy_ref_1.LazyRefPrpMarker && fieldEtc.propertyOptions.lazyDirectRawRead) {
                    //providing new readable (flipped) NodeJS.ReadableStream from cache
                    if (thisLocal.attachRefId) {
                        throw new Error('LazyRefBase.subscribe: thisLocal.attachRefId must be null when this.lazyLoadedObj is not null. Me:\n' +
                            this);
                    }
                    thisLocalNextOnAsync.value = true;
                    var getFromCache$ = this.session.manager.config.cacheHandler.getFromCache(this.attachRefId);
                    var fromDirectRaw$ = getFromCache$
                        .pipe(rxjs_util_1.flatMapJustOnceRxOpr(function (stream) {
                        return fieldEtc.fieldProcessorCaller.callFromDirectRaw(rxjs_1.of({
                            body: stream,
                        }), fieldEtc.fieldInfo);
                    }), operators_1.map(function (respL) {
                        return respL;
                    }));
                    // fromDirectRaw$ = fromDirectRaw$.pipe(thisLocal.session.addSubscribedObsRxOpr());
                    fromDirectRaw$ = fromDirectRaw$.pipe(operators_1.tap({
                        next: function (repValue) {
                            thisLocal.setLazyObjOnLazyLoadingNoNext(repValue.body);
                            if (!observerNew.closed) {
                                if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                                    thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()). !observerNew.closed');
                                    thisLocal.consoleLikeSubs.debug('calling this.next()');
                                    thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                                    thisLocal.consoleLikeSubs.groupEnd();
                                }
                                observerNew.closed = true;
                                thisLocal.nextProt(true, thisLocal.lazyLoadedObj, observerOriginal);
                            }
                            else {
                                if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                                    thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()). observerNew.closed');
                                    thisLocal.consoleLikeSubs.debug('NOT calling this.next()');
                                    thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                                    thisLocal.consoleLikeSubs.groupEnd();
                                }
                            }
                        },
                        error: observerNew.error,
                        complete: observerNew.complete,
                        closed: observerNew.closed
                    }));
                    fromDirectRaw$ = fromDirectRaw$.pipe(thisLocal.session.registerProvidedObservablesRxOpr(), operators_1.take(1));
                    fromDirectRaw$.subscribe(function () {
                        //thisLocal.nextPriv(respValue.body);
                        //nothing
                    });
                }
            }
            if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                thisLocal.consoleLikeSubs.debug('(thisLocal.lazyLoadedObj != null)\n'
                    + 'It may mean that we already have subscribed yet in the Observable of Response\n '
                    + 'or this was created with lazyLoadedObj already loaded.');
            }
            if (!observerNew.closed && !thisLocalNextOnAsync.value) {
                thisLocal.nextProt(false, thisLocal.lazyLoadedObj, observerOriginal);
            }
            return resultSubs;
        };
        LazyRefMTODefault.prototype.processResponse = function (responselike) {
            var thisLocal = this;
            var mdRefererObj = { $iAmPlayerMetadatas$: true };
            var fieldEtc = recorder_manager_default_1.RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(this.session.fielEtcCacheMap, this.refererObj, this.refererKey, this.session.manager.config);
            if (this.genericNode.gType !== lazy_ref_1.LazyRefMTOMarker) {
                throw new Error('Wrong type: ' + this.genericNode.gType.name + '. Me:\n' + this);
            }
            var playerSnapshot;
            playerSnapshot = responselike.body;
            if (lodash_like_1.LodashLike.has(this.refererObj, this.session.manager.config.playerMetadatasName)) {
                mdRefererObj = lodash_like_1.LodashLike.get(this.refererObj, this.session.manager.config.playerMetadatasName);
            }
            if (this.lazyLoadedObj == null) {
                if (thisLocal.consoleLikeProcResp.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                    thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: LazyRef.lazyLoadedObj is not setted yet: Me:\n' + this);
                }
                if (thisLocal.consoleLikeProcResp.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                    thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: LazyRef for a relationship. Me:\n' + this);
                }
                var processedEntity = this.session.processWrappedSnapshotFieldInternal(fieldEtc.lazyLoadedObjType, playerSnapshot.wrappedSnapshot);
                this.setLazyObjOnLazyLoadingNoNext(processedEntity);
                //was the only way I found to undock the Observable<L> from the Observable<Response>
                //  The side effect of this is that map() called before this exchange is
                //  not piped with new Observable.
            }
            if (this.signatureStr) {
                if (!this.session.isOnRestoreEntireStateFromLiteral()) {
                    if (!mdRefererObj.$signature$ && !mdRefererObj.$isComponentPlayerObjectId$) {
                        throw new Error('The referer object has no mdRefererObj.$signature$. This should not happen. Me:\n' + this);
                    }
                    if (!mdRefererObj.$signature$) {
                        if (thisLocal.consoleLikeProcResp.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                            thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: (!mdRefererObj.$signature$): owner entity not found for LazyRef, the owner must be a player side component. Me:\n' + this);
                        }
                    }
                    this.session.storeOriginalLiteralEntry({
                        method: 'lazyRef',
                        ownerSignatureStr: mdRefererObj.$signature$,
                        ownerFieldName: this.refererKey,
                        playerSnapshot: playerSnapshot,
                        ref: {
                            iAmAnEntityRef: true,
                            signatureStr: thisLocal.signatureStr
                        }
                    });
                }
                if (thisLocal.consoleLikeProcResp.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                    thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: IS LazyRefPrp, NOT keeping reference by signature. Me:\n' + this);
                }
            }
            return thisLocal.lazyLoadedObj;
        };
        Object.defineProperty(LazyRefMTODefault.prototype, "playerObjectId", {
            get: function () {
                return this._playerObjectId;
            },
            set: function (value) {
                this._playerObjectId = value;
            },
            enumerable: true,
            configurable: true
        });
        return LazyRefMTODefault;
    }(lazy_ref_base_1.LazyRefBase));
    exports.LazyRefMTODefault = LazyRefMTODefault;
});
//# sourceMappingURL=lazy-ref-mto-default.js.map