var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "rxjs", "../api/recorder-config", "rxjs/operators", "./recorder-constants", "./recorder-manager-default", "../api/lazy-ref", "../api/generic-tokenizer", "../api/tape", "./tape-default", "./lodash-like", "./lazy-ref-base"], factory);
    }
})(function (require, exports) {
    Object.defineProperty(exports, "__esModule", { value: true });
    var rxjs_1 = require("rxjs");
    var recorder_config_1 = require("../api/recorder-config");
    var operators_1 = require("rxjs/operators");
    var recorder_constants_1 = require("./recorder-constants");
    var recorder_manager_default_1 = require("./recorder-manager-default");
    var lazy_ref_1 = require("../api/lazy-ref");
    var generic_tokenizer_1 = require("../api/generic-tokenizer");
    var tape_1 = require("../api/tape");
    var tape_default_1 = require("./tape-default");
    var lodash_like_1 = require("./lodash-like");
    var lazy_ref_base_1 = require("./lazy-ref-base");
    /**
     * Default implementation!
     * See {@link LazyRef}
     */
    var LazyRefOTMDefault = /** @class */ (function (_super) {
        __extends(LazyRefOTMDefault, _super);
        function LazyRefOTMDefault(session) {
            var _this = _super.call(this, session) || this;
            _this.iAmLazyRefOTM = true;
            return _this;
        }
        LazyRefOTMDefault.prototype.setLazyObj = function (lazyLoadedObj, observerOriginal) {
            var _this = this;
            var thisLocal = this;
            //const asyncCombineObsArr: Observable<any>[] = [];
            var fieldEtc = recorder_manager_default_1.RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(this.session.fielEtcCacheMap, this.refererObj, this.refererKey, this.session.manager.config);
            if (!fieldEtc.propertyOptions) {
                throw new Error('@RecorderDecorators.property() not defined for ' + this.refererObj.constructor.name + '.' + this.refererKey);
            }
            //Validating
            if (!this.refererObj || !this.refererKey) {
                throw new Error('The property \'' + this.refererKey + ' has no refererObj or refererKey' + '. Me:\n' + this);
            }
            if (fieldEtc.prpGenType == null) {
                throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\' is not decorated with com \'@Reflect.metadata("design:generics", GenericTokenizer\'...' + '. Me:\n' + this);
            }
            if (fieldEtc.prpGenType.gType !== lazy_ref_1.LazyRefOTMMarker) {
                throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\' is not LazyRef. Me:\n' + this);
            }
            if ((fieldEtc.otmCollectionType === Set || fieldEtc.otmCollectionType === Array) && !this.isOnLazyLoading) {
                throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\' can not be changed because this is a collection: \'' + fieldEtc.otmCollectionType.name + '\'' + '. Me:\n' + this);
            }
            //null to response.
            this.respObs = null;
            var isValueByFieldProcessor = { value: false };
            if (!this.session.isOnRestoreEntireStateFromLiteral() && !this.isOnLazyLoading) {
                if (!this.session.isRecording()) {
                    throw new Error('Invalid operation. It is not recording. Is this Error correct?! Me:\n' + this);
                }
                if (this.lazyLoadedObj !== lazyLoadedObj) {
                    if (thisLocal.consoleLike.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                        thisLocal.consoleLike.group('LazyRefDefault.setLazyObj()' +
                            '(this.lazyLoadedObj === lazyLoadedObj)\n' +
                            'NOT recording action: ' + tape_1.TapeActionType.SetField + '. actual and new value: ');
                        thisLocal.consoleLike.debug(this.lazyLoadedObj);
                        thisLocal.consoleLike.debug(lazyLoadedObj);
                        thisLocal.consoleLike.groupEnd();
                    }
                    var mdRefererObj = this.bMdRefererObj;
                    var mdLazyLoadedObj = this.bMdLazyLoadedObj;
                    //recording tape
                    var action_1 = new tape_default_1.TapeActionDefault();
                    action_1.fieldName = this.refererKey;
                    action_1.actionType = tape_1.TapeActionType.SetField;
                    action_1.attachRefId = thisLocal.attachRefId;
                    if (mdRefererObj.$signature$) {
                        action_1.ownerSignatureStr = mdRefererObj.$signature$;
                    }
                    else if (lodash_like_1.LodashLike.has(this.refererObj, this.session.manager.config.creationIdName)) {
                        action_1.ownerCreationRefId = lodash_like_1.LodashLike.get(this.refererObj, this.session.manager.config.creationIdName);
                    }
                    else if (!this.isOnLazyLoading && !mdRefererObj.$isComponentPlayerObjectId$) {
                        throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\' has a not managed owner. Me:\n' + this);
                    }
                    if (lazyLoadedObj != null) {
                        if (mdLazyLoadedObj.$signature$) {
                            action_1.settedSignatureStr = mdLazyLoadedObj.$signature$;
                        }
                        else if (lodash_like_1.LodashLike.has(lazyLoadedObj, this.session.manager.config.creationIdName)) {
                            action_1.settedCreationRefId = lodash_like_1.LodashLike.get(lazyLoadedObj, this.session.manager.config.creationIdName);
                        }
                        else if (fieldEtc.lazyRefMarkerType === lazy_ref_1.LazyRefPrpMarker) {
                            //nothing for now!
                        }
                        else if (!this.isOnLazyLoading) {
                            throw new Error('The property \'' + this.refererKey + ' from \'' + this.refererObj.constructor.name + '\'.  lazyLoadedObj is not managed: \'' + lazyLoadedObj.constructor.name + '\'' + '. Me:\n' + this);
                        }
                    }
                    if (fieldEtc.lazyRefMarkerType === lazy_ref_1.LazyRefPrpMarker) {
                        if (fieldEtc.propertyOptions.lazyDirectRawWrite) {
                            isValueByFieldProcessor.value = true;
                            var processTapeActionAttachRefId$ = thisLocal.session.processTapeActionAttachRefId({ fieldEtc: fieldEtc, value: lazyLoadedObj, action: action_1, propertyKey: thisLocal.refererKey });
                            //processTapeActionAttachRefId$ = processTapeActionAttachRefId$.pipe(thisLocal.session.addSubscribedObsRxOpr());
                            processTapeActionAttachRefId$ = processTapeActionAttachRefId$.pipe(thisLocal.mapJustOnceKeepAllFlagsRxOpr(function (ptaariValue) {
                                if (!ptaariValue.asyncAddTapeAction) {
                                    thisLocal.session.addTapeAction(action_1);
                                }
                                if (thisLocal.attachRefId !== action_1.attachRefId) {
                                    throw new Error('This should not happen');
                                }
                                _this.setLazyObjMayDoNextHelper(isValueByFieldProcessor, fieldEtc, ptaariValue.newValue, null);
                                return ptaariValue;
                            }), thisLocal.session.registerProvidedObservablesRxOpr());
                            var subs_1 = processTapeActionAttachRefId$.subscribe(function () {
                                if (subs_1) {
                                    subs_1.unsubscribe();
                                }
                            });
                            thisLocal.lazyLoadedObj = null;
                            thisLocal.respObs = rxjs_1.of(null).pipe(operators_1.flatMap(function () {
                                return thisLocal.session.manager.config.cacheHandler.getFromCache(thisLocal.attachRefId);
                            }), operators_1.map(function (stream) {
                                return { body: stream };
                            }));
                            //asyncCombineObsArr.push(processTapeActionAttachRefId$);
                        }
                        else if (fieldEtc.fieldProcessorCaller && fieldEtc.fieldProcessorCaller.callToLiteralValue) {
                            isValueByFieldProcessor.value = true;
                            var toLiteralValue$ = fieldEtc.fieldProcessorCaller.callToLiteralValue(action_1.simpleSettedValue, fieldEtc.fieldInfo);
                            // toLiteralValue$ = toLiteralValue$.pipe(this.session.addSubscribedObsRxOpr());
                            toLiteralValue$ = toLiteralValue$.pipe(operators_1.tap({
                                next: function (value) {
                                    action_1.simpleSettedValue = value;
                                    thisLocal.session.addTapeAction(action_1);
                                }
                            }), thisLocal.session.registerProvidedObservablesRxOpr(), operators_1.share());
                            //asyncCombineObsArr.push(toLiteralValue$);
                        }
                        else {
                            this.session.addTapeAction(action_1);
                        }
                    }
                }
                else {
                    if (thisLocal.consoleLike.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                        thisLocal.consoleLike.group('LazyRefDefault.setLazyObj()' +
                            '(this.lazyLoadedObj !== lazyLoadedObj)\n' +
                            'Recording action: ' + tape_1.TapeActionType.SetField + '. value: ');
                        thisLocal.consoleLike.debug(lazyLoadedObj);
                        thisLocal.consoleLike.groupEnd();
                    }
                }
            }
            if (!isValueByFieldProcessor.value && fieldEtc.prpGenType.gType !== lazy_ref_1.LazyRefPrpMarker) {
                if (this.lazyLoadedObj !== lazyLoadedObj) {
                    if (this.lazyLoadedObj) {
                        this.session.unregisterEntityAndLazyref(this.lazyLoadedObj, this);
                    }
                }
            }
            else {
            }
            this.setLazyObjMayDoNextHelper(isValueByFieldProcessor, fieldEtc, lazyLoadedObj, observerOriginal);
        };
        LazyRefOTMDefault.prototype.asObservable = function () {
            var _this = this;
            var thisLocal = this;
            var fieldEtc = recorder_manager_default_1.RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(this.session.fielEtcCacheMap, this.refererObj, this.refererKey, this.session.manager.config);
            if (!fieldEtc.propertyOptions.lazyDirectRawWrite) {
                return _super.prototype.asObservable.call(this);
            }
            else {
                //providing new readable (flipped) NodeJS.ReadableStream from cache
                //this.respObs is never null
                if (!fieldEtc.propertyOptions.lazyDirectRawWrite) {
                    throw new Error('LazyRefBase.subscribe: thisLocal.attachRefId is not null but this is not lazyDirectRawWrite. Me:\n' +
                        this);
                }
                var localObs$ = thisLocal.respObs;
                var localObsL$ = localObs$.pipe(thisLocal.flatMapKeepAllFlagsRxOpr(function (respLikeStream) {
                    var processResponseOnLazyLoading = thisLocal.processResponseOnLazyLoading(respLikeStream);
                    if (rxjs_1.isObservable(processResponseOnLazyLoading)) {
                        var processResponseOnLazyLoading$ = processResponseOnLazyLoading;
                        return processResponseOnLazyLoading$;
                    }
                    else {
                        return _this.thrownError(new Error('This should not happen soud not happen.This LazyRef is lazyDirectRawWrite'));
                    }
                }), 
                //thisLocal.session.registerLazyRefSubscriptionRxOpr(thisLocal.signatureStr),
                thisLocal.session.registerProvidedObservablesRxOpr(), operators_1.tap({
                    next: function () {
                        if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                            thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()).');
                            thisLocal.consoleLikeSubs.debug('calling this.next(). attachRefId is not null. Am I using lazyDirectRawWrite? Me:\n' + thisLocal);
                            thisLocal.consoleLikeSubs.groupEnd();
                        }
                    }
                }), operators_1.share());
                return localObsL$;
            }
        };
        LazyRefOTMDefault.prototype.subscribe = function (observerOrNext, error, complete) {
            var thisLocal = this;
            var resultSubs = null;
            var fieldEtc = recorder_manager_default_1.RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(this.session.fielEtcCacheMap, this.refererObj, this.refererKey, this.session.manager.config);
            if (fieldEtc.propertyOptions.lazyDirectRawWrite) {
                throw new Error('lazyDirectRawWrite can not be used with LazyRefOTM');
            }
            if (fieldEtc.propertyOptions.lazyDirectRawRead) {
                throw new Error('lazyDirectRawRead can not be used with LazyRefOTM');
            }
            //super.subscribe() only for non lazyDirectRawWrite
            if (observerOrNext instanceof rxjs_1.Subscriber) {
                resultSubs = _super.prototype.subscribe.call(this, observerOrNext);
            }
            else {
                resultSubs = _super.prototype.subscribe.call(this, observerOrNext, error, complete);
            }
            var observerOriginal = this.createAndRegisterObserverOriginal(observerOrNext, error, complete);
            var observerNew = __assign({}, observerOriginal);
            var thisLocalNextOnAsync = { value: false };
            if (thisLocal.lazyLoadedObj == null) {
                if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                    thisLocal.consoleLikeSubs.debug('(thisLocal.lazyLoadedObj == null)\n'
                        + 'It may mean that we have not subscribed yet in the Observable of Response');
                }
                if (this.respObs == null) {
                    if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeSubs.debug('(this.respObs == null)\n'
                            + 'Means that we already subscribed to an earlier moment in the Observable of Reponse.\n'
                            + 'We will simply call the super.subscribe and call  next()');
                    }
                }
                else {
                    if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeSubs.debug('(thisLocal.respObs != null)\n'
                            + 'Means that we are not subscribed yet in the Observable of Reponse.\n'
                            + 'this.respObs will be null after subscription, so we mark that '
                            + 'there is already an inscription in the Response Observable, and we ' +
                            'will not make two trips to the server');
                    }
                    //return thisLocal.processResponseOnLazyLoading(response);
                    var localObs$ = thisLocal.respObs.pipe(thisLocal.session.logRxOpr('LazyRef_subscribe_respObs'), thisLocal.mapJustOnceKeepAllFlagsRxOpr(function (responseLike) {
                        var processResponseOnLazyLoading = thisLocal.processResponseOnLazyLoading(responseLike);
                        return processResponseOnLazyLoading;
                    }));
                    thisLocalNextOnAsync.value = true;
                    observerNew.next = function (value) {
                        if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                            thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => observerNew.next()');
                            thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                            thisLocal.consoleLikeSubs.groupEnd();
                        }
                        thisLocal.setLazyObjOnLazyLoadingNoNext(value);
                        if (!observerNew.closed) {
                            if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                                thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()). !observerNew.closed');
                                thisLocal.consoleLikeSubs.debug('calling this.next()');
                                thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                                thisLocal.consoleLikeSubs.groupEnd();
                            }
                            observerNew.closed = true;
                            //here the original method will be called
                            thisLocal.nextProt(false, thisLocal.lazyLoadedObj, observerOriginal);
                        }
                        else {
                            if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                                thisLocal.consoleLikeSubs.group('(Asynchronous of Asynchronous of...) LazyRef.subscribe() => getFromCache$.subscribe() => fromDirectRaw$.subscribe() => setLazyObjOnLazyLoading$.pipe(tap()). observerNew.closed');
                                thisLocal.consoleLikeSubs.debug('NOT calling this.next()');
                                thisLocal.consoleLikeSubs.debug(thisLocal.lazyLoadedObj);
                                thisLocal.consoleLikeSubs.groupEnd();
                            }
                        }
                    };
                    thisLocalNextOnAsync.value = true;
                    localObs$ = localObs$.pipe(thisLocal.session.registerLazyRefSubscriptionRxOpr(thisLocal.signatureStr), thisLocal.session.registerProvidedObservablesRxOpr(), operators_1.tap(function () {
                        //so we will mark that you already hear an entry in the Response Observable, and we will not make two trips to the server.
                        //lazyDirectRawWrite is always readed from cache.
                        if (!fieldEtc.propertyOptions.lazyDirectRawWrite) {
                            thisLocal.respObs = null;
                        }
                    }), operators_1.share());
                    localObs$.subscribe(observerNew);
                }
            }
            else {
                //nothing
            }
            if (thisLocal.consoleLikeSubs.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                thisLocal.consoleLikeSubs.debug('(thisLocal.lazyLoadedObj != null)\n'
                    + 'It may mean that we already have subscribed yet in the Observable of Response\n '
                    + 'or this was created with lazyLoadedObj already loaded.');
            }
            if (!observerNew.closed && !thisLocalNextOnAsync.value) {
                thisLocal.nextProt(false, thisLocal.lazyLoadedObj, observerOriginal);
            }
            return resultSubs;
        };
        LazyRefOTMDefault.prototype.processResponse = function (responselike) {
            var thisLocal = this;
            var fieldEtc = recorder_manager_default_1.RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(this.session.fielEtcCacheMap, this.refererObj, this.refererKey, this.session.manager.config);
            if (!fieldEtc.propertyOptions.lazyDirectRawWrite) {
                thisLocal.session.validatePlayerSideResponseLike(responselike);
            }
            var playerSnapshot;
            playerSnapshot = responselike.body;
            if (this.lazyLoadedObj == null) {
                if (thisLocal.consoleLikeProcResp.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                    thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: LazyRef.lazyLoadedObj is not setted yet: Me:\n' + this);
                }
                if (fieldEtc.otmCollectionType) {
                    if (!(this.genericNode instanceof generic_tokenizer_1.GenericNode) || this.genericNode.gParams[0].gParams.length <= 0) {
                        throw new Error('LazyRef not defined: \'' + this.refererKey + '\' of ' + this.refererObj.constructor.name + '. Me:\n' + this);
                    }
                    if (thisLocal.consoleLikeProcResp.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: LazyRef is collection: ' + fieldEtc.lazyLoadedObjType.name);
                    }
                    var collTypeParam = null;
                    if (this.genericNode.gParams[0].gParams[0] instanceof generic_tokenizer_1.GenericNode) {
                        collTypeParam = this.genericNode.gParams[0].gParams[0].gType;
                    }
                    else {
                        collTypeParam = this.genericNode.gParams[0].gParams[0];
                    }
                    if (thisLocal.consoleLikeProcResp.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                        thisLocal.consoleLikeProcResp.debug('LazyRefBase.processResponse: LazyRef is collection of: ' + collTypeParam.name);
                    }
                    var lazyLoadedColl = this.session.createCollection(fieldEtc.otmCollectionType, this.refererObj, this.refererKey);
                    lodash_like_1.LodashLike.set(lazyLoadedColl, recorder_constants_1.RecorderConstants.ENTITY_IS_ON_LAZY_LOAD_NAME, true);
                    try {
                        this.session.processWrappedSnapshotFieldArrayInternal(collTypeParam, lazyLoadedColl, playerSnapshot.wrappedSnapshot);
                        this.setLazyObjOnLazyLoadingNoNext(lazyLoadedColl);
                    }
                    finally {
                        lodash_like_1.LodashLike.set(this.lazyLoadedObj, recorder_constants_1.RecorderConstants.ENTITY_IS_ON_LAZY_LOAD_NAME, false);
                    }
                }
                else {
                    throw new Error('Wrong type: ' + this.genericNode.gType.name + '. Me:\n' + this);
                }
            }
            return thisLocal.lazyLoadedObj;
        };
        return LazyRefOTMDefault;
    }(lazy_ref_base_1.LazyRefBase));
    exports.LazyRefOTMDefault = LazyRefOTMDefault;
});
//# sourceMappingURL=lazy-ref-otm-default.js.map