(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "rxjs", "rxjs/operators", "./rxjs-util"], factory);
    }
})(function (require, exports) {
    Object.defineProperty(exports, "__esModule", { value: true });
    var rxjs_1 = require("rxjs");
    var operators_1 = require("rxjs/operators");
    var rxjs_util_1 = require("./rxjs-util");
    var toStream = require('blob-to-stream');
    var toBlob = require('stream-to-blob');
    var RecorderForDom;
    (function (RecorderForDom) {
        RecorderForDom.CacheHandlerDefault = {
            clearCache: function () {
                return rxjs_1.from(caches.open('jshb_cachestorage'))
                    .pipe(operators_1.map(function (cache) {
                    return rxjs_1.from(cache.keys())
                        .pipe(rxjs_util_1.flatMapJustOnceRxOpr(function (requests) {
                        var obsArr = [];
                        for (var _i = 0, requests_1 = requests; _i < requests_1.length; _i++) {
                            var req = requests_1[_i];
                            obsArr.push(rxjs_1.from(cache.delete(req)));
                        }
                        if (obsArr.length > 0) {
                            return rxjs_util_1.combineFirstSerial(obsArr);
                        }
                        else {
                            return rxjs_1.of(null);
                        }
                    }));
                }))
                    .pipe(operators_1.map(function () { }));
            },
            getFromCache: function (cacheKey) {
                return rxjs_1.from(caches.open('jshb_cachestorage'))
                    .pipe(rxjs_util_1.flatMapJustOnceRxOpr(function (cache) {
                    return rxjs_1.from(cache.match(cacheKey));
                }))
                    .pipe(rxjs_util_1.flatMapJustOnceRxOpr(function (response) {
                    return rxjs_1.from(response.blob());
                }))
                    .pipe(rxjs_util_1.flatMapJustOnceRxOpr(function (blob) {
                    return rxjs_1.of(toStream(blob));
                }));
            },
            putOnCache: function (cacheKey, stream) {
                return rxjs_1.from(caches.open('jshb_cachestorage'))
                    .pipe(operators_1.map(function (cache) {
                    return rxjs_1.from(cache.put(cacheKey, new Response(toBlob(stream), null)))
                        .pipe(operators_1.map(function () { }));
                }))
                    .pipe(operators_1.map(function () { }));
            },
            removeFromCache: function (cacheKey) {
                return rxjs_1.from(caches.open('jshb_cachestorage'))
                    .pipe(operators_1.map(function (cache) {
                    return rxjs_1.from(cache.delete(cacheKey))
                        .pipe(operators_1.map(function () { }));
                }))
                    .pipe(operators_1.map(function () { }));
            }
        };
    })(RecorderForDom = exports.RecorderForDom || (exports.RecorderForDom = {}));
});
//# sourceMappingURL=native-for-dom.js.map