var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./recorder-constants", "rxjs", "./recorder-manager-default", "../api/lazy-ref", "../api/recorder-config", "../api/tape", "./tape-default", "rxjs/operators", "stream-to-observable", "./mem-stream-readable-stream-auto-end", "./lodash-like"], factory);
    }
})(function (require, exports) {
    Object.defineProperty(exports, "__esModule", { value: true });
    var recorder_constants_1 = require("./recorder-constants");
    var rxjs_1 = require("rxjs");
    var recorder_manager_default_1 = require("./recorder-manager-default");
    var lazy_ref_1 = require("../api/lazy-ref");
    var recorder_config_1 = require("../api/recorder-config");
    var tape_1 = require("../api/tape");
    var tape_default_1 = require("./tape-default");
    var operators_1 = require("rxjs/operators");
    var stream_to_observable_1 = __importDefault(require("stream-to-observable"));
    var mem_stream_readable_stream_auto_end_1 = require("./mem-stream-readable-stream-auto-end");
    var lodash_like_1 = require("./lodash-like");
    var RecorderDecoratorsInternal;
    (function (RecorderDecoratorsInternal) {
        function property() {
            var options = { persistent: true };
            if (arguments.length > 0) {
                options = arguments[0];
            }
            var optionsConst = {
                persistent: true
            };
            if (options) {
                Object.assign(optionsConst, options);
            }
            if (!optionsConst.fieldProcessorEvents) {
                optionsConst.fieldProcessorEvents =
                    {};
            }
            var returnFunc = function (target, propertyKey, descriptor) {
                Reflect.defineMetadata(recorder_constants_1.RecorderConstants.REFLECT_METADATA_PLAYER_OBJECT_PROPERTY_OPTIONS, optionsConst, target, propertyKey);
                var oldSet = descriptor.set;
                descriptor.set = function (value) {
                    var thisLocal = this;
                    var session = lodash_like_1.LodashLike.get(this, recorder_constants_1.RecorderConstants.ENTITY_SESION_PROPERTY_NAME);
                    var consoleLike = session.manager.config.getConsole(recorder_config_1.RecorderLogger.RecorderDecorators);
                    var fieldEtc = recorder_manager_default_1.RecorderManagerDefault.resolveFieldProcessorPropOptsEtc(session.fielEtcCacheMap, target, propertyKey.toString(), session.manager.config);
                    if (fieldEtc.propertyOptions.persistent) {
                        if (consoleLike.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                            consoleLike.group('JsonPlayback.set' +
                                'propertyOptions.persistent. Intercepting set method for ' + target.constructor.name + '.' + propertyKey + '. target and value:');
                            consoleLike.debug(target);
                            consoleLike.debug(value);
                            consoleLike.groupEnd();
                        }
                        var isOnlazyLoad = lodash_like_1.LodashLike.get(this, recorder_constants_1.RecorderConstants.ENTITY_IS_ON_LAZY_LOAD_NAME);
                        if (value && value.iAmLazyRef) {
                            //nothing
                        }
                        else {
                            if (lodash_like_1.LodashLike.isObject(target, new Set([Date, Buffer]))) {
                                if (!session) {
                                    throw new Error('The property \'' + propertyKey.toString() + '\' of \'' + target.constructor + '\' has a not managed owner. \'' + recorder_constants_1.RecorderConstants.ENTITY_SESION_PROPERTY_NAME + '\' is null or not present');
                                }
                                var actualValue = lodash_like_1.LodashLike.get(this, propertyKey.toString());
                                if (actualValue !== value) {
                                    if (!isOnlazyLoad && !session.isOnRestoreEntireStateFromLiteral()) {
                                        if (!session.isRecording()) {
                                            throw new Error('Invalid operation. It is not recording. is this Error correct?!');
                                        }
                                        if (consoleLike.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                                            consoleLike.group('JsonPlayback.set' +
                                                '(actualValue !== value) && !isOnlazyLoad && !session.isOnRestoreEntireStateFromLiteral()\n' +
                                                'Recording action: ' + tape_1.TapeActionType.SetField + '. actual and new value: ');
                                            consoleLike.debug(actualValue);
                                            consoleLike.debug(value);
                                            consoleLike.groupEnd();
                                        }
                                        //do the TapeAction log here
                                        var action_1 = new tape_default_1.TapeActionDefault();
                                        action_1.fieldName = propertyKey.toString();
                                        action_1.actionType = tape_1.TapeActionType.SetField;
                                        var allMD = session.resolveMetadatas({ object: this });
                                        var bMd = allMD.objectMd;
                                        if (bMd.$signature$) {
                                            action_1.ownerSignatureStr = bMd.$signature$;
                                        }
                                        else if (lodash_like_1.LodashLike.has(this, session.manager.config.creationIdName)) {
                                            action_1.ownerCreationRefId = lodash_like_1.LodashLike.get(this, session.manager.config.creationIdName);
                                        }
                                        else if (!this._isOnInternalSetLazyObjForCollection) {
                                            throw new Error('The property \'' + propertyKey.toString() + ' of \'' + target.constructor + '\' has a not managed owner');
                                        }
                                        var asyncAddTapeAction = { value: false };
                                        if (value != null && value != undefined) {
                                            var allMD_1 = session.resolveMetadatas({ object: value });
                                            var bMdValue = allMD_1.objectMd;
                                            if (bMdValue.$signature$) {
                                                action_1.settedSignatureStr = bMdValue.$signature$;
                                            }
                                            else if (lodash_like_1.LodashLike.has(value, session.manager.config.creationIdName)) {
                                                action_1.settedCreationRefId = lodash_like_1.LodashLike.get(value, session.manager.config.creationIdName);
                                            }
                                            else {
                                                if (lodash_like_1.LodashLike.isObject(value, new Set([Date, Buffer]))) {
                                                    throw new Error('The property \'' + propertyKey.toString() + ' of \'' + this.constructor + '\'. Value can not be anything but primitive in this case. value: ' + value.constructor);
                                                }
                                                action_1.simpleSettedValue = value;
                                            }
                                        }
                                        else {
                                            action_1.simpleSettedValue = null;
                                        }
                                        if (fieldEtc.propertyOptions.lazyDirectRawWrite) {
                                            var processTapeActionAttachRefId$ = session.processTapeActionAttachRefId({ fieldEtc: fieldEtc, value: value, action: action_1, propertyKey: propertyKey.toString() });
                                            //processTapeActionAttachRefId$ = processTapeActionAttachRefId$.pipe(session.addSubscribedObsRxOpr());
                                            asyncAddTapeAction.value = true;
                                            processTapeActionAttachRefId$ = processTapeActionAttachRefId$.pipe(session.registerProvidedObservablesRxOpr(), operators_1.share());
                                            processTapeActionAttachRefId$.subscribe({
                                                next: function (ptaariValue) {
                                                    oldSet.call(thisLocal, ptaariValue.newValue);
                                                    if (!ptaariValue.asyncAddTapeAction) {
                                                        session.addTapeAction(action_1);
                                                    }
                                                }
                                            });
                                            // action.attachRefId = session.manager.config.cacheStoragePrefix + session.nextMultiPurposeInstanceId();
                                            // if (fieldEtc.fieldProcessorCaller && fieldEtc.fieldProcessorCaller.callToDirectRaw) {
                                            //     let toDirectRaw$ = fieldEtc.fieldProcessorCaller.callToDirectRaw(value, fieldEtc.fieldInfo);
                                            //     toDirectRaw$ = toDirectRaw$.pipe(session.addSubscribedObsRxOpr());
                                            //     asyncAddTapeAction.value = true;
                                            //     toDirectRaw$.subscribe((stream) => {
                                            //         if (stream) {
                                            //             let putOnCache$ = session.manager.config.cacheHandler.putOnCache(action.attachRefId, stream)
                                            //             putOnCache$ = putOnCache$.pipe(session.addSubscribedObsRxOpr());
                                            //             putOnCache$.subscribe(() => {
                                            //                 session.addTapeAction(action);
                                            //             });
                                            //             let getFromCache$ = session.manager.config.cacheHandler.getFromCache(action.attachRefId);
                                            //             getFromCache$ = getFromCache$.pipe(session.addSubscribedObsRxOpr());
                                            //             getFromCache$.subscribe((stream) => {
                                            //                 oldSet.call(this, stream);
                                            //             });
                                            //         } else {
                                            //             if (value) {
                                            //                 throw new Error('The property \'' + propertyKey.toString() + ' of \'' + this.constructor + '\'. NodeJS.ReadableStream is null but value is not null. value: ' + value.constructor);
                                            //             }
                                            //             action.simpleSettedValue = null;
                                            //             action.attachRefId = null;
                                            //             session.addTapeAction(action);
                                            //         }
                                            //     });
                                            // } else {
                                            //     if (!((value as any as NodeJS.ReadableStream).addListener && (value as any as NodeJS.ReadableStream).pipe)) {
                                            //         throw new Error('The property \'' + propertyKey.toString() + ' of \'' + this.constructor + '\'. There is no "IFieldProcessor.toDirectRaw" defined and value is not a NodeJS.ReadableStream. value: ' + value.constructor);
                                            //     } else {
                                            //         let putOnCache$ = session.manager.config.cacheHandler.putOnCache(action.attachRefId, value as any as NodeJS.ReadableStream);
                                            //         putOnCache$ = putOnCache$.pipe(session.addSubscribedObsRxOpr());
                                            //         asyncAddTapeAction.value = true;
                                            //         putOnCache$.subscribe(() => {
                                            //             session.addTapeAction(action);
                                            //         });
                                            //         let getFromCache$ = session.manager.config.cacheHandler.getFromCache(action.attachRefId);
                                            //         getFromCache$ = getFromCache$.pipe(session.addSubscribedObsRxOpr());
                                            //         getFromCache$.subscribe((stream) => {
                                            //             oldSet.call(this, stream);
                                            //         });
                                            //     }
                                            // }
                                        }
                                        else if (fieldEtc.fieldProcessorCaller && fieldEtc.fieldProcessorCaller.callToLiteralValue) {
                                            var processedValue = fieldEtc.fieldProcessorCaller.callToLiteralValue(value, fieldEtc.fieldInfo);
                                            // toLiteralValue$ = toLiteralValue$.pipe(session.addSubscribedObsRxOpr());
                                            asyncAddTapeAction.value = false;
                                            action_1.simpleSettedValue = processedValue;
                                        }
                                        else {
                                            action_1.simpleSettedValue = value;
                                        }
                                        if (!asyncAddTapeAction.value) {
                                            session.addTapeAction(action_1);
                                        }
                                    }
                                }
                                else {
                                    if (consoleLike.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                                        consoleLike.group('JsonPlayback.set' +
                                            '(actualValue === value)\n' +
                                            'NOT recording action, BUT may process : ' + tape_1.TapeActionType.SetField + '. value: ');
                                        consoleLike.debug(value);
                                        consoleLike.groupEnd();
                                    }
                                }
                            }
                        }
                        oldSet.call(this, value);
                        if (session && !isOnlazyLoad) {
                            session.notifyAllLazyrefsAboutEntityModification(this, null);
                        }
                    }
                    else {
                        oldSet.call(this, value);
                        if (consoleLike.enabledFor(recorder_config_1.RecorderLogLevel.Trace)) {
                            consoleLike.group('JsonPlayback.set' +
                                '!(propertyOptions.persistent && genericNode.gType !== LazyRef && genericNode.gType !== LazyRefPrpMarker). Not intercepting set method for ' + target.constructor.name + '.' + propertyKey + '. target and value:');
                            consoleLike.debug(target);
                            consoleLike.debug(value);
                            consoleLike.groupEnd();
                        }
                    }
                };
            };
            return returnFunc;
        }
        RecorderDecoratorsInternal.property = property;
        function playerObjectId() {
            return function (target, propertyKey) {
                var playerObjectIdType = Reflect.getMetadata('design:type', target, propertyKey);
                Reflect.defineMetadata(recorder_constants_1.RecorderConstants.REFLECT_METADATA_PLAYER_OBJECT_ID_TYPE, playerObjectIdType, target);
            };
        }
        RecorderDecoratorsInternal.playerObjectId = playerObjectId;
        /**
         * Decorator for persistent entity.
         *
         * Sample:
         * ```ts
         * ...
         * @JsonPlayback.playerType({playerType: 'org.mypackage.MyPersistentEntity'})
         * export class MyPersistentEntityJs {
         * ...
         * ```
         */
        function playerType(options) {
            return function (target) {
                Reflect.defineMetadata(recorder_constants_1.RecorderConstants.REFLECT_METADATA_PLAYER_TYPE, options, target);
                Reflect.defineMetadata(mountContructorByPlayerTypeMetadataKey(options, target), target, Function);
            };
        }
        RecorderDecoratorsInternal.playerType = playerType;
        /**
         * Internal use only! It is no a decorator!
         */
        function mountContructorByPlayerTypeMetadataKey(options, entityType) {
            return recorder_constants_1.RecorderConstants.REFLECT_METADATA_JSCONTRUCTOR_BY_PLAYER_TYPE_PREFIX +
                entityType.name +
                (options.disambiguationId ? ':' + options.disambiguationId : '') +
                ':' + options.playerType;
        }
        RecorderDecoratorsInternal.mountContructorByPlayerTypeMetadataKey = mountContructorByPlayerTypeMetadataKey;
        // export const BufferProcessor: IFieldProcessor<Buffer> = {
        //     fromLiteralValue: (value, info) => {
        //         if (value) {
        //             return of(Buffer.from(value, 'base64'));
        //         } else {
        //             return of(null);
        //         }
        //     },
        //     toLiteralValue: (value, info) => {
        //         if (value) {
        //             let base64Str = value.toString('base64');                            
        //             return of(base64Str);
        //         }
        //     }
        // };
        // export const StringProcessor: IFieldProcessor<String> = {
        //     fromLiteralValue: (value: string, info: any) => {
        //         return of(value);
        //     },
        //     fromDirectRaw: (stream: NodeJS.ReadableStream, info: any) => {
        //         return from(getStream(stream, {}) as Promise<string>);
        //     }
        // };
        // export const NodeJS.ReadableStreamProcessor: IFieldProcessor<String> = {
        //     fromLiteralValue: (value, info) => {
        //         if (value) {
        //             let base64AB = Buffer.from(value, 'base64');
        //             let ws = new memStreams.WritableStream();
        //             ws.write(base64AB);
        //             let myReadableStreamBuffer = new memStreams.ReadableStream(''); 
        //             myReadableStreamBuffer.push(base64AB);
        //             return of(myReadableStreamBuffer);
        //         } else {
        //             return of(null);
        //         }
        //     },
        //     fromDirectRaw: (stream, info) => {
        //         if (stream) {
        //             if ((stream as NodeJS.ReadableStream).addListener && (stream as NodeJS.ReadableStream).pipe) {
        //                 return of(stream);
        //             } else {
        //                 throw new Error('Not supported');
        //             }
        //         } else {
        //             return of(null);
        //         }
        //     }
        // };
        // export const StringStreamProcessor: IFieldProcessor<StringStream> = {
        //         fromLiteralValue: (value, info) => {
        //             if (value) {
        //                 let base64AB = Buffer.from(value, 'base64');
        //                 let ws = new memStreams.WritableStream();
        //                 ws.write(base64AB);
        //                 let myReadableStreamBuffer = new memStreams.ReadableStream(value); 
        //                 myReadableStreamBuffer.setEncoding('utf-8');
        //                 return of(myReadableStreamBuffer);
        //             } else {
        //                 return of(null);
        //             }
        //         },
        //         fromDirectRaw: (stream, info) => {
        //             if (stream) {
        //                 if ((stream as NodeJS.ReadableStream).addListener && (stream as NodeJS.ReadableStream).pipe) {
        //                     (stream as any as Readable).setEncoding('utf-8');
        //                     return of(stream);
        //                 } else {
        //                     throw new Error('Not supported');
        //                 }
        //             } else {
        //                 return of(null);
        //             }
        //         }
        // };
        RecorderDecoratorsInternal.DateProcessor = {
            fromLiteralValue: function (value) {
                if (value instanceof Number || typeof (value) === 'number') {
                    return new Date(value);
                }
                else if (value instanceof String || typeof (value) === 'string') {
                    return new Date(value);
                }
                else {
                    return null;
                }
            },
            toLiteralValue: function (value) {
                if (value) {
                    return value.getTime();
                }
                else {
                    return null;
                }
            }
        };
        RecorderDecoratorsInternal.BufferProcessor = {
            fromLiteralValue: function (value) {
                if (value) {
                    return Buffer.from(value, 'base64');
                }
                else {
                    return null;
                }
            },
            fromDirectRaw: function (respStream$) {
                return respStream$.pipe(operators_1.flatMap(function (respStream) {
                    if (respStream) {
                        var chunkConcatArrRef_1 = { value: [] };
                        return rxjs_1.from(stream_to_observable_1.default(respStream.body)
                            .forEach(function (chunk) {
                            chunkConcatArrRef_1.value.push(chunk);
                        })).pipe(operators_1.map(function () {
                            return { body: Buffer.concat(chunkConcatArrRef_1.value) };
                        }));
                    }
                    else {
                        return rxjs_1.of({ body: null });
                    }
                }));
            },
            toLiteralValue: function (value) {
                if (value) {
                    var base64Str = value.toString('base64');
                    return rxjs_1.of(base64Str);
                }
                else {
                    return rxjs_1.of(null);
                }
            },
            toDirectRaw: function (value) {
                if (value) {
                    // let ws = new memStreams.WritableStream();
                    // ws.write(value);
                    var myReadableStreamBuffer = new mem_stream_readable_stream_auto_end_1.MemStreamReadableStreamAutoEnd('');
                    myReadableStreamBuffer.push(value);
                    return rxjs_1.of({ body: myReadableStreamBuffer });
                    // return of(null).pipe(
                    //     tap(() => {
                    //         myReadableStreamBuffer.emit('end');
                    //     }),
                    //     map(() => {
                    //         return myReadableStreamBuffer;
                    //     })
                    // );
                }
                else {
                    return rxjs_1.of({ body: null });
                }
            }
        };
        RecorderDecoratorsInternal.StringProcessor = {
            fromLiteralValue: function (value) {
                return value;
            },
            fromDirectRaw: function (respStream$) {
                return respStream$.pipe(operators_1.flatMap(function (respStream) {
                    if (respStream.body) {
                        respStream.body.setEncoding('utf8');
                        var chunkConcatArrRef_2 = { value: [] };
                        return rxjs_1.from(stream_to_observable_1.default(respStream.body)
                            .forEach(function (chunk) {
                            if (typeof (chunk) === 'string') {
                                chunkConcatArrRef_2.value.push(chunk);
                            }
                            else if (chunk instanceof String) {
                                chunkConcatArrRef_2.value.push(chunk.toString());
                            }
                            else {
                                throw new Error('Not supported!: chunk: ' + chunk);
                            }
                        })).pipe(operators_1.map(function () {
                            var bufferConc = ''.concat.apply('', chunkConcatArrRef_2.value);
                            return bufferConc;
                        }));
                    }
                    else {
                        return rxjs_1.of(null);
                    }
                }));
            },
            toLiteralValue: function (value) {
                return value;
            },
            toDirectRaw: function (value) {
                if (value) {
                    var myReadableStreamBuffer = new mem_stream_readable_stream_auto_end_1.MemStreamReadableStreamAutoEnd(value.toString());
                    myReadableStreamBuffer.setEncoding('utf-8');
                    return rxjs_1.of({ body: myReadableStreamBuffer });
                }
                else {
                    return rxjs_1.of({ body: null });
                }
            }
        };
        RecorderDecoratorsInternal.BinaryStreamProcessor = {
            fromLiteralValue: function (value) {
                if (value) {
                    var base64AB = Buffer.from(value, 'base64');
                    var myReadableStreamBuffer = new mem_stream_readable_stream_auto_end_1.MemStreamReadableStreamAutoEnd(base64AB.toString());
                    var binaryWRStream = Object.assign(myReadableStreamBuffer, lazy_ref_1.NonWritableStreamExtraMethods);
                    return binaryWRStream;
                }
                else {
                    return null;
                }
            },
            fromDirectRaw: function (respStream$) {
                return respStream$.pipe(operators_1.flatMap(function (respStream) {
                    if (respStream.body) {
                        if (respStream.body.addListener && respStream.body.pipe) {
                            return rxjs_1.of(respStream);
                        }
                        else {
                            throw new Error('Not supported');
                        }
                    }
                    else {
                        return rxjs_1.of({ body: null });
                    }
                }));
            },
            toDirectRaw: function (value) {
                if (value) {
                    return rxjs_1.of({ body: value });
                }
                else {
                    return rxjs_1.of({ body: null });
                }
            },
            toLiteralValue: function () {
                throw new Error('Not supported!');
            }
        };
        RecorderDecoratorsInternal.StringStreamProcessor = {
            fromLiteralValue: function (value) {
                if (value) {
                    // let ws = new memStreams.WritableStream();
                    // ws.write(valueBuffer);
                    var myReadableStreamBuffer = new mem_stream_readable_stream_auto_end_1.MemStreamReadableStreamAutoEnd(value);
                    myReadableStreamBuffer.setEncoding('utf-8');
                    return myReadableStreamBuffer;
                }
                else {
                    return null;
                }
            },
            fromDirectRaw: function (respStream$) {
                return respStream$.pipe(operators_1.flatMap(function (respStream) {
                    if (respStream.body) {
                        if (respStream.body.addListener && respStream.body.pipe) {
                            respStream.body.setEncoding('utf-8');
                            return rxjs_1.of(respStream);
                        }
                        else {
                            throw new Error('Not supported');
                        }
                    }
                    else {
                        return rxjs_1.of({ body: null });
                    }
                }));
            },
            toDirectRaw: function (value) {
                if (value) {
                    value.setEncoding('utf8');
                    return rxjs_1.of({ body: value });
                }
                else {
                    return rxjs_1.of({ body: null });
                }
            },
            toLiteralValue: function () {
                throw new Error('Not supported!');
            }
        };
    })(RecorderDecoratorsInternal = exports.RecorderDecoratorsInternal || (exports.RecorderDecoratorsInternal = {}));
});
//# sourceMappingURL=recorder-decorators-internal.js.map